// Auto-Loot.js
//
// Automatic looting and stacking utility

//	Copyright (c) 2002,2003 by David A. Down (Merlyn of Harvestion)

//**Start Encode**

var Title="Auto-Loot", Vers="1.3.5", Title2="Enter Name";
var handler= new EventHandler();	// Global event handler object
var fso = new ActiveXObject("Scripting.FileSystemObject"), ForWriting=2; // File functions
var LootAll=false, Cfg={}, aTime=skapi.TimerNew(), tTime=skapi.TimerNew();
var xpTotal, dTotal, Unspent, dUnspent, dSkill, Skill={}; // For XP tracking
var Task={}, WaitFor=0, WaitTime, eTime=skapi.TimerNew(); // For queueing tasks
var KilledByMe, Me, Pack, Opened, Vendor, Contents, Hot=false, Home, Armor=0;
var Corpses=null, NextCorpse, HoldCorpses=null, buyCnt=0, IgnoreS=false, Check=false;
var Quit=false, Log=false, Deb=false, xpLog=false, Auto, Chat=false, AutoS;
var IDwait=2200, Tusk, LootCnt, MissCnt, CCnt, MD=null, Hole, Catch, L126, Gnd, GndLoot;
var Char={}, Spell={}, cMask, cfgFile=Title+"@"+skapi.szWorld+".cfg", CST=null;
var Action, Attacker, Target, Weapon, GMtype, GM, MaxCharge=0.075, Cost, Val, word=null;
var Scarab=3, Scroll=3, pyMax=10000, Ratio=3, Range=0.3, Value=2000, Eat=true, EatP=80;
var Tank=false, Friends= {}, HotKeys= {K:"kill", L:"loot"}; // Default hotkeys
var Color= {Black:0, Red:255, Green:65280, Yellow:65535, Blue:16711680,
		Magenta:16711935, Cyan:16776960, White:16777215}; // Color values for controls
var Mnemosyne= {Tiny:5000, Small:25000, Large:75000}; // Mnemosyne estimated values
var MnemKeys= {Tiny:"Wooden", Small:"Copper", Large:"Obsidian"}; // Keys to unlock Mnemosynes
var ElixirName= {"Health Elixir":1,"Mana Elixir":2,"Stamina Elixir":4,
		"Potion of Healing":8,"Mana Potion":16,"Stamina Potion":32}, Elixirs;
var ScarabName= {Lead:1,Iron:2,Copper:3,Silver:4,Gold:5,Pyreal:6,Platinum:7}; // Levels
var Loot= {"Pyreal":true,"Trade Note":true}, Pause="{pause}", LootAttack=false, Salvage;
var LootName= new RegExp("Bronze .* Statue|(Salvaged|Gem of) .*|.* Key");
var FishName= ["*Fish","* Molly","* Guppy","* Minnow"], FishC;
var Nav=false, LocCnt, GoLoc= {'Rithwic Smith':"10.83N 58.62E",'Rithwic->Lyt.':"9.54N 59.95E"};
var Schema=null, NoSell, One=false, MaxCnt, KillCnt, LocCnt, NameSchema, Looting, Find=false;
var Material={},MtlCode={},MtlName={Agate:materialAgate,Alabaster:materialAlabaster,
	Aquamarine:materialAquamarine,'Armoredillo Hide':materialDilloHide,Azurite:materialAzurite,
	'Black Garnet':materialBlackGarnet,'Black Opal':materialBlackOpal,Bloodstone:materialBloodstone,
	Brass:materialBrass,Bronze:materialBronze,Carnelian:materialCarnelian,Ceramic:materialCeramic,
	Copper:materialCopper,Ebony:materialEbony,Emerald:materialEmerald,'Fire Opal':materialFireOpal,
	Gold:materialGold,Granite:materialGranite,Hematite:materialHematite,
	'Imperial Topaz':materialImperialTopaz,Iron:materialIron,Ivory:materialIvory,Jet:materialJet,
	'Lapis Lazuli':materialLapisLazuli,'Lavender Jade':materialLavenderJade,Leather:materialLeather,
	Linen:materialLinen,Mahogany:materialMahogany,Malachite:materialMalachite,Marble:materialMarble,
	Moonstone:materialMoonstone,Oak:materialOak,Opal:materialOpal,Peridot:materialPeridot,Pine:materialPine,
	Porcelain:materialPorcelain,'Red Garnet':materialRedGarnet,'Red Jade':materialRedJade,
	'Reedshark Hide':materialReedsharkHide,'Rose Quartz':materialRoseQuartz,Silk:materialSilk,
	Silver:materialSilver,'Smokey Quartz':materialSmokeyQuartz,Steel:materialSteel,
	Sunstone:materialSunstone,Teak:materialTeak,Velvet:materialVelvet,'White Sapphire':materialWhiteSapphire,
	Wool:materialWool,'Yellow Topaz':materialYellowTopaz,Zircon:materialZircon};
var MemberID={}, AllegianceID={}, Sex=[,"M","F"], Race=[,"Aluv.","Gharu.","Sho"];
var mtyOnMemberLogin= 0xF7B0027A-0x100000000, mtyAllegianceInfo= 0xF7B00020-0x100000000;
var Weapons={Axe:0,Bow:0,Crossbow:0,Dagger:0,Mace:0,Spear:0,Staff:0,Sword:0,Thrown:0,Unarmed:0};
var WeaponID=[13,"Axe","Bow","Crossbow","Dagger","Mace",,,,"Spear","Staff","Sword","Thrown","Unarmed"];
var Dsk={}, Ask={}, mcmWeapon= mcmWeaponsMelee | mcmWeaponsMissile; // Combined weapon types
var Msk={A:{}, D:{M:skidMeleeDefense,R:skidMissileDefense,W:skidMagicDefense}};
var Ranged={"Atlatl":60,"Light Crossbow":60,"Shortbow":60}; // Short ranged weapons
var DmgType={'(none)':0,Slashing:1,Piercing:2,Bludgeoning:3,Cold:4,Fire:5,Acid:6,Electrical:7};
var Cantrip=false, SpellMin=2501, SpellMax=2628;	// Spell ID range for cantrips
var Restore={H:[0,8,11,16,26,38,51,75],S:[0,11,16,26,38,51,76,100]};
var S2H=[0,1664,1665,1666,16671,1668,1669,2343], S2M=[0,1676,1677,1678,1679,1680,1681,2345];
var Revitalize=[0,1177,1178,1179,1180,1181,1182,2083];
var FSxp=0, Fpct=[0,1.00,0.75,0.60,0.55,0.50,0.45,0.40,0.35,0.31]; // Fellowship xp
//var StamTo=[,75,90,105,120,135,150,175];
Ask[skidBow]= Ask[skidCrossbow]= Ask[skidThrownWeapons]= "R";
Ask[skidCreatureEnchantment]= Ask[skidLifeMagic]= Ask[skidWarMagic]= "W";
Ask[skidAxe]= Ask[skidDagger]= Ask[skidMace]= Ask[skidSpear]=
		Ask[skidStaff]= Ask[skidSword]= Ask[skidUnarmedCombat]= "M";
Dsk[skidMeleeDefense]= "M", Dsk[skidMissileDefense]= "R", Dsk[skidMagicDefense]= "W";

// Everything starts here
function main() {
	if(skapi.szVersion<"2.4") {Msg("Error: Skunkworks v2.4 or later required."); return;}
	if(include(Title+".xml")) {Msg("Error: "+Title+".xml not found."); return;}
	if(!Schema) {Msg("Error: Control panel schema not defined."); return;}
	if(include(Title+".cfg")) Msg("Warning: "+Title+".cfg not found.");
	if(include(Title+".loot")) Msg("Warning: "+Title+".loot not found.");
	include(cfgFile);			// Add scroll info if available
	include(Title+".md");		// Add monster info if available
	BuildMtlCode();				// Build code list
	while(!Quit && skapi.plig>pligNotRunning) { // The game must be running
		DefineHandlers();		//	Prepare to handle control events.
		while(skapi.plig<pligInWorld) { // Wait until logged in
			if(skapi.plig==pligNotRunning) return; // Quit on game termination
			skapi.WaitEvent(1000);		// Wait for a status change
		}
		Msg("Version "+Vers+" starting.");
		skapi.ShowControls(Schema,true); // Display the control panel
		initVars();				// Initialize the global variables
		initChar();				// Init character spell data
		PackSetup();			// Find out where things are stored

//	Process events until the Quit flag is set or we log out
		while(!Quit && skapi.plig>pligAtLogin) { // Make sure we're logged in
			TaskDo();			// Process the task list
			if(WaitFor) {		// Do we have somehing specific to wait for?
				var event= WaitFor;
				WaitFor= 0;		// Clear the flag for next time
				eTime.cmsec= 0; // Reset elapsed timer
				skapi.WaitEvent(WaitTime,wemSpecific,event);
				if(Log) Msg("Wait="+WaitTime+", Elapsed="+eTime.cmsec);
				if(WaitTime>1000 || event==evidOnOpenContainer) // Lag sensitive
					skapi.WaitEvent(150,wemFullTimeout); // Make sure its had time to finish
			} else skapi.WaitEvent(200);
		}
		skapi.RemoveControls(Title); // Remove the control panel
		if(Hot) for(key in HotKeys) skapi.Hotkey(key,false); // Remove the hotkeys
		RemoveHandlers();		// Remove the control handlers
	}
}

function Assess(aco) {	// Common assess function
	if(aco.oai) return 0;
	skapi.AssessAco(aco);			// Force an item assess
	if(!aco.fExists) return 1;	// Object gone?
	skapi.WaitEvent(IDwait,wemSpecific,evidOnAssessItem); // Wait for it to complete
	return !aco.oai;
}

function AddSpell(spid) {	// Add a spell to the spell list
	var spinfo= skapi.SpellInfoFromSpellid(spid); // Get info for this spell
	return Spell[spid]= 1<<(spinfo.skid-skidCreatureEnchantment); // Add new entry
}

function AddSpells() {	// Update the spell list for this user
	var spid, spinfo, cnt=skapi.rgspellid(-1,-1), mask=cMask&-16;
	Msg("Adding "+cnt+" known spells to configuration.");
	while(cnt--) {					// Process all known spells
		spid= skapi.rgspellid(-1,cnt); // Get the next spell id
		if(!Spell[spid]) AddSpell(spid); // Is this a new spell entry?
		Spell[spid] |= mask;		// Set bit for this player
	}
}

function BuildLocs() {	// Build location list for control
	var name;
	Msg("Building location list...");
	for(name in GoLoc) { // Process each entry
		skapi.GetControlProperty(Title,"cmLoc","AddChoice('"+name+"')");
		skapi.SetControlProperty(Title,"cmLoc","Data('"+(LocCnt++)+"')",GoLoc[name]);
	}
	Msg("Location list is done.");
}

function BuildMtlCode() { // Build code list for materials
	var name,code;
	for(name in Material) { // Get each material type to loot
		code= MtlName[name];	// Get the code value
		if(!code) {Msg("Warning: '"+name+"' is an unrecognized material!"); continue;}
		MtlCode[code]= Material[name]; // Add to code list
	}
}

function Caps(str) { // Capitalize the words in the string
	var word= str.split(" ");	// Split string into words
	var cnt= word.length;		// Word count
	while(cnt--) {				// Process all words
		word[cnt]= word[cnt].slice(0,1).toUpperCase() + word[cnt].slice(1);
	}
	return word.join(" ");
}

function ChatMsg(str) { // Send output to the chat window
	if(Chat && Chat!=true) str= Chat+" "+str;	// Prefix string?
	skapi.Chat(chrmLocal,str);		// Output string
}

function ChatSize(vpos) { // Adjust vertical position for chat window size
	var diff= skapi.dypWindow/4-34; // Change in text window size
	return skapi.clrPixel(-321,-88) ? vpos-diff : vpos; // Adjust if large
}

function CheckScroll(spid,test) {	// Set the current list of magic skills
	var bits, cnt, name, str="", skill;
	var spinfo= skapi.SpellInfoFromSpellid(spid); // Get info for this spell
	var mask= Spell[spid];			// Get the mask bits for this spell
	if(mask) {						// Is it a configured spell?
		skill= mask & 0xF;			// Get the magic skill type
		mask &= ~0xF;				// Remove skill bit from mask
	} else { mask=0; skill= AddSpell(spid);}
	for(cnt=Char[0];cnt;cnt--) {	// Check all defined characters
		name= Char[cnt];			// Get the next name
		bits= Char[name];			// Get the mask bits for this char
		if(!(bits&skill)) continue;	// Skip if not trained in this skill
		if(bits&mask) continue;		// Skip if already known
		if(str!="") str += ", ";
		str += name;				// Add name to list
	}
	if(test) return str=="";		// Test for unusable scrolls?
	if(str=="") str="(nobody)";
	Msg("'"+spinfo.szName+"' can be used by: "+str);
	return spinfo;
}

function CombatMode(target) { // Make sure we are in combat mode
	if(!skapi.fCombatMode) {	// In combat mode?
		skapi.Keys(cmidToggleCombat); // Switch modes
		skapi.WaitEvent(900,wemSpecific,evidOnCombatMode); // Wait for it to complete
		if(target) skapi.WaitEvent(1000,wemFullTimeout); // Wait for auto-target selection
	}
}

function Compass(heading,detail) { // Convert heading to compass direction
	var str="", dir= Math.floor(heading/45*4);
	switch(detail) {
	case 3:
		if((dir+1)&2) {			// 3-char direction?
			str= "NESW".charAt(((dir+5)>>3)&3); // Add modifier
			dir= (dir&~4)|2;	// Force next direction range
		}
	default:
	case 2:
		if((dir+2)&4) {			// Mixed direction?
			str += (dir+10)&16 ? "S" : "N"; // Add modifier
			dir= (dir&~8)|4;	// Force next direction range
		}
	case 1:
		str += "NESW".charAt(((dir+4)>>3)&3); // Set main direction
	}
	return str;
}

function DecodeFriends(msg) { // Track friends on/off
	var n;
	var line= msg.split("\n"); // May be multiple lines
	for(n in line) {			// Multi-line message?
		var word= line[n].split(/ (i|ha)s logged /); // Parse it
		var name= word[0], state= word[1];
		LogFriend(name,state=="on.");
	}
}

function FmtNbr(nbr) { // Return a comma formatted string for a number
	var fstr="", str=nbr.toFixed(0), len= nbr<0 ? 4 : 3;
	while(str.length>len) {		// Is another comma needed?
		fstr= ","+str.slice(-3)+fstr;
		str= str.slice(0,-3);	// Remove the last 3 digits
	}
	return str+fstr;
}

function GetObject(aco) { // Get an object, allowing for location
	var myloc= skapi.maplocCur; // My current location
	var turn= (360+myloc.head-myloc.HeadToMaploc(aco.maploc))%360; // Turning required
	if(turn>180) turn= 360-turn; // Adjust for left turn
	var dist= myloc.Dist2DToMaploc(aco.maploc); // Get distance
	aco.Use();				// Get the object
	if(dist<.069) dist *= 3; // Adjust for walking distance?
	WaitTime= Math.round(1200+35000*dist+15*turn); // Adjust for distance & turn
}

function Hex(nbr) { // Return the unsigned hexadecimal string for a number
	var rbits= 0x10000 + (0xffff & nbr);
	var lbits= 0x10000 + (nbr >>> 16);
	return "0x"+lbits.toString(16).slice(1)+rbits.toString(16).slice(1);
}

function include(name) { // Include the evaluated contents of a file
    if(Log) Msg("Including file '"+name+"'.");
	if(!fso.FileExists(name)) return -1; // Does the data file exist?
	cf = fso.OpenTextFile(name,ForReading);
	eval(cf.ReadAll());				// Evaluate the file contents
	cf.Close();
	return 0;
}

function initChar() {	// Initialize the character spell list
	var i, cNbr, cName= skapi.szName, bit=1, skinfo, skid=skidCreatureEnchantment;
	if(Char[cName]) {				// Is this character defined?
		for(cNbr=Char[0];cNbr;cNbr--) if(Char[cNbr]==cName) break;
		cMask= Char[cName]&-16;		// Bit mask for spells
	} else {
		if(!Char[0]) Char[0]= 0;	// Define if needed
		cNbr= ++Char[0];			// Advance character count
		Char[cNbr]= cName;			// Save the name
		cMask= 0x8 << cNbr;			// Bit mask for spells
	}
	for(;skid<=skidWarMagic;skid++,bit<<=1) { // Check all 4 magic skills
		skinfo= skapi.SkinfoFromSkid(skid); // Get info for this skill
		if(skinfo.skts>sktsUntrained) cMask |= bit; // Set skill bit
	}
	if(!Char[cName]) AddSpells();	// Now add the spells
	Char[cName]= cMask;				// Save the spell mask
	for(i=Char[0];i;i--) {			// Add all the character names
		var str= "AddChoice('"+Char[i]+"')";
		skapi.GetControlProperty(Title,"cmChar",str); // Add name to list
	}
}

function initVars() { // Initialize the global variables
	var skid=skidMax, skinfo, key, name, Amax={M:0,R:0,W:0}, tp;
	var C = Cfg[skapi.szName+"@"+skapi.szWorld]; // Select the config for this char
	if(typeof(C)!="undefined") for(name in C) switch(name) { // Got config?
	case "Armor": Armor=C.Armor; break;
	case "Cantrip": Cantrip=C.Cantrip; break;
	case "Check": Check=C.Check; break;
	case "Eat": SetCtlValue("cbEat",Eat=C.Eat); break;
	case "EatP": SetCtlValue("tbEatP",EatP=C.EatP); break;
	case "Find": SetCtlValue("cbFind",Find=C.Find); break;
	case "Gnd": Gnd=C.Gnd; break;
	case "Hot": SetCtlValue("cbHot",Hot=C.Hot);
		if(Hot) for(key in HotKeys) skapi.Hotkey(key,true);
		break;
	case "LootAll": SetCtlValue("cbAll",LootAll=C.LootAll); break;
	case "LootAttack": LootAttack=C.LootAttack; break;
	case "Range": SetCtlValue("tbRng",(Range=C.Range)*100); break;
	case "Ratio": SetCtlValue("tbRat",Ratio=C.Ratio); break;
	case "Scarab": SetCtlValue("tbScrb",Scarab=C.Scarab); break;
	case "Scroll": SetCtlValue("tbScrl",Scroll=C.Scroll); break;
	case "Tank": SetCtlValue("cbTank",(Tank=C.Tank)>0); break;
	case "Value": SetCtlValue("tbValue",Value=C.Value); break;
	case "xpLog": SetCtlValue("cbXP",xpLog=C.xpLog); break;
	}
	Msk.A={M:0,R:0,W:0};			// Reset attack skills
	xpTotal= skapi.expTotal;		// Current total xp
	Unspent= skapi.expUnspent;		// Current unspent xp
	Skill= {};
	while(--skid) {					// Check all possible skills
		skinfo= skapi.SkinfoFromSkid(skid); // Get the skill info
		if(skinfo==null) continue;	// Skip undefined skill ids
		Skill[skid]= skinfo.expInvested; // Save current total skill xp
		if(!Ask[skid]) continue;	// Skip non-attack skill ids
		tp= Ask[skid];				// Get skill attack type
		if(skinfo.lvlUnbuffed<=Amax[tp]) continue; // Less than best?
		Amax[tp]= skinfo.lvlUnbuffed; // Set new best value
		Msk.A[tp]= skid;			// Remember skill
	}
	KilledByMe= "Killed by "+skapi.szName+"."; // Corpse desc. for my kills
	Corpses= skapi.CoacoNew();		// Empty corpse object collection
	HoldCorpses= skapi.CoacoNew();	// Empty corpse object collection
	Contents= skapi.CoacoNew();		// Empty container contents collection
	Salvage= skapi.CoacoNew();		// Empty salvage collection
	GndLoot= skapi.CoacoNew();		// Empty loot collection
	Target= Weapon= dUnspent= LocCnt= Catch= 0;
	NextCorpse= Attacker= Action= Home= Hole= Vendor= null;
	Opened={}, NoSell={};
	Task.first= Task.last= 0;		// Init.task list
	Auto= AutoS= Tusk= Find= false;
	L126= skapi.lvl>125;			// Flag for max level
	xpTotal= skapi.expTotal;		// Total xp
	Looting= true;
}

function LogFriend(name,state) { // Track friends on/off
	var time= new Date();
	if(!Friends[name]) Friends[name]= {on:0,off:0}; // Defined?
	var friend= Friends[name];
	if(!state) friend.off= time;
	else if(friend.on && friend.off && friend.on>friend.off) ; // Dup?
	else friend.on= time;
	if(Log) Msg("Friend "+name+" is "+state);
	if(friend.on && friend.off) {
		var time= (friend.off-friend.on)/60000; // Time on in min.
		if(time>0) Msg(name+" was on for "+time.toFixed(1)+" min.");
		else Msg(name+" was off for "+(-time).toFixed(1)+" min.");
	}
}

function MaxLvl(skid) { // Calculate maximum spell level for a given magic skill
	var skill= skapi.SkinfoFromSkid(skid).lvlCur; // Get current skill level
	return skill ? Math.floor(skill/50)+1 : 0;
}

function Msg(str) { // Send output to the message window
	if(Chat) {ChatMsg(Title+": "+str); return;} // Send to chat?
	if(Deb) {skapi.OutputLine(str,opmDebugLog); return;} // Send to debug?
	skapi.OutputSz(Title+": ",opmChatWnd,cmcRose); // Message prefix
	skapi.OutputLine(str,opmChatWnd);	// Output string to message window
}

// Generate a text string representation of an object that can be evaluated to restore it
function ObjectToString(item,wrap) {
	var name,list="";
	if(typeof(item)=="undefined") return "undefined";
	if(item==null) return "null";
	if(typeof(item)=="string") return '"'+item+'"';
	if(typeof(item)!="object") return item.toString();
	for(name in item) {			// Loop through all the object properties
		if(list) list += ",";	// Use delimiter after first property
		if(wrap) list += "\n  ";	// Start new line for sub-object?
		if(name.indexOf("'")<0) list += "'"+name+"':"; // Use (')?
		else list += '"'+name+'":'; // Alternate quotes
		list += ObjectToString(item[name]); // Expand each element
	}
	if(wrap) list += "\n";		// Start new line for ending?
	return "{"+list+"}";
}

function PackNbr(aco) { // Find the pack # that a container object may be
	var Pack= skapi.cpack;		// # of packs to check
	while(Pack--) if(aco==skapi.AcoFromIpackIitem(Pack,-1)) break; // Stop when found
	return Pack;				// Return pack # (-1 if not found)
}

function PackSetup() { // Find out where things are stored
	var aco, name, desc="Elixirs/Potions found: ";
	Me= skapi.acoChar, Pack= {};	// Init pack objects
	Pack.Scarab= Me;				// Default to main pack
	Elixirs= 0;
	for(name in ElixirName) {
		aco= skapi.AcoFindInInv(name); // Find an elixir
		if(!aco) continue;
		if(Elixirs) desc += ", ";	// Skip on first one
		desc += name;
		Elixirs |= ElixirName[name]; // Set flag
		Pack[name]= aco.acoContainer; // Remember where to put them
	}
	if(Elixirs) Msg(desc);			// Note if elixirs added
	var scarab= skapi.AcoFindInInv("* Scarab");		// Find a scarab
	if(!scarab) return;				// Give up if none found
	var packS= scarab.acoContainer; // What pack is it in?
	Pack.Scarab= packS;				// Find the pack that its in
	if(packS!=Me) Msg("Scarabs found in pack #"+PackNbr(packS));
}

function RestoreMana(pct) { // Restore mana to given %
	var lvl=LifeLvl= MaxLvl(skidLifeMagic); // Level to cast Life spells at
	var manaLvl=skapi.SkinfoFromVital(vitalManaMax).lvlCur*pct/100; // Desired mana
	if(skapi.manaCur<manaLvl) {		// Need mana?
		skapi.CastSpell(S2M[lvl]);	// Cast Stamina to Mana
		skapi.WaitEvent(3000,wemSpecific,evidOnActionComplete); // Wait for it to complete
	}
}

function RestoreVitals(pct) { // Restore vitals to given %
	var lvl=LifeLvl= MaxLvl(skidLifeMagic); // Level to cast Life spells at
	var healthLvl=skapi.SkinfoFromVital(vitalHealthMax).lvlCur*pct/100; // Desired health
	while(skapi.healthCur<healthLvl) { // Need health?
		RestoreMana(50);			// Restore mana if low
		var mana=skapi.manaCur;		// Current mana
		if(mana<lvl*10) lvl= Math.floor(mana/10); // Reduce level if low mana
		skapi.CastSpell(S2H[lvl]);	// Cast Stamina to Health
		skapi.WaitEvent(3000,wemSpecific,evidOnActionComplete); // Wait for it to complete
	}
	RestoreMana(50);				// Restore mana if low
	var stamMax=skapi.SkinfoFromVital(vitalStaminaMax).lvlCur; // Current max stamina
	var stamLvl=stamMax*pct/100;	// Minimum desired stamina
	while(skapi.staminaCur<stamLvl) { // Need stamina?
		RestoreMana(50);			// Restore mana if low
		var dif=stamMax-skapi.staminaCur; // Amount that can be restored
		for(lvl=1;lvl<7;lvl++) {	// Find level needed
			if(Restore.S[lvl]>=dif) break; // High enough level?
		}
		if(lvl>LifeLvl) lvl= LifeLvl; // Too high for skill?
		skapi.CastSpell(Revitalize[lvl]); // Cast Stamina to Mana
		skapi.WaitEvent(3000,wemSpecific,evidOnActionComplete); // Wait for it to complete
	}
	RestoreMana(pct);				// Restore mana if low
}

function RunTo(aco,dist) { // Run towards an object and return when close to it
	skapi.GoToMaploc(aco.maploc,dist);	// Run towards the target
	Nav= 2;						// Indicate navigation in progress
	skapi.WaitEvent(20000,wemSpecific,evidOnNavStop); // Wait for it to complete
	return Nav<0;				// Error
}

function SaveCfg(filename) {	// Save configuration data for each player
	cf = fso.OpenTextFile(filename, ForWriting, true);	// Create config file
	cf.WriteLine("// Auto-Loot character configuration data.  Be careful to preserve the syntax!\n");
	cf.WriteLine("Armor = "+Armor+";");
	cf.WriteLine("MemberID = "+ObjectToString(MemberID,false)+";");
	cf.WriteLine("HotKeys = "+ObjectToString(HotKeys,false)+";");
	cf.WriteLine("Material = "+ObjectToString(Material,false)+";");
	cf.WriteLine("Weapons = "+ObjectToString(Weapons,false)+";");
	cf.WriteLine("Cfg = "+ObjectToString(Cfg,true)+";");
	cf.WriteLine("GoLoc = "+ObjectToString(GoLoc,true)+";");
	cf.Close();
}

function SaveSpellCfg(filename) {	// Save spell configuration data for each player
	cf = fso.OpenTextFile(filename, ForWriting, true);	// Create config file
	cf.WriteLine("// Auto-Loot character spell data.  Do not edit!\n");
	cf.WriteLine("Char = "+ObjectToString(Char,false)+";");
	cf.WriteLine("Spell = "+ObjectToString(Spell,false)+";");
	cf.Close();
}

function SetCtlCheck(control,state) { // Set the check box of a control
	skapi.SetControlProperty(Title,control,"checked",state);
}

// Set the text color of a control to green (on) or black (off)
function SetCtlColor(control,state) {
	skapi.SetControlProperty(Title,control,"textcolor",state ? Color.Green : Color.Black);
}

function SetCtlValue(control,value) { // Set the text value of a control
	if(control.charAt(0)=="t") skapi.SetControlProperty(Title,control,"text",value);
	else skapi.SetControlProperty(Title,control,"checked",value);
}

function SkillField(obj,field) { // Set the Att/Def skill fields
	var tp, AD="D", bias=0, skill, color;
	for(tp in obj) {		// Find each member
		color=0xC0;			// Default=Red
		skapi.SetControlProperty(Title,field+tp,"text",obj[tp]);
		if(field=="stTD") AD= "A", bias= -30; // Attack skill?
		skill= Msk[AD][tp];	// Skill ID if trained
		if(skill) {			// Do we have this skill type?
			skill= skapi.SkinfoFromSkid(skill).lvlCur; // Get level?
			if(tp=="R") skill *= 1.5; // 'full-pull' ranged bonus?
			if(skill>obj[tp]+bias) color= 0xD0F0; // Yellow;
			if(skill>obj[tp]+50+bias) color= 0xE000; // Green
		}
		skapi.SetControlProperty(Title,field+tp,"textcolor",color);
	}
}

function SkillStr(obj) { // Build an Att/Def skill string
	var t, s="";
	for(t in obj) {		// Find each member
		if(s) s += ", "; // Add delimiter?
		s += t+obj[t];	// Add member
	}
	return s;			// Return the string
}

function SortByValueWeight(aco1,aco2) { // Compare value/weight of 2 acos
	if(Assess(aco1)) return 1;	// Assess if needed
	if(Assess(aco2)) return -1;	// Assess if needed
	return aco1.cpyValue/aco1.oai.ibi.burden-aco2.cpyValue/aco2.oai.ibi.burden;
}

function SortByWeight(aco1,aco2) { // Compare weight of 2 acos
	if(Assess(aco1)) return 1;	// Assess if needed
	if(Assess(aco2)) return -1;	// Assess if needed
	return aco2.oai.ibi.burden-aco1.oai.ibi.burden;
}

function ToD(date) { // Return Time of Day, given a date object
	return date.getHours()+":"+date.getMinutes()+":"+date.getSeconds();
}

// ***** Action functions start here *****

function DoFish() {				// We are trying to catch fish
	if(!Catch) return;
	Catch= 0;
	Hole.Use();		// Try to catch something
	tTime.cmsec= -7000;			// Restart timer
}

function DoKill() {				// We are trying to kill stuff
	if(Tank) {					// Is tank in control?
		var delay= Tank>2 ? Tank*1000 : 7000; // Default timeout?
		if(Auto && Looting && aTime.cmsec>delay && Corpses.Count) { // Is Tank idle?
			Msg("Pausing to loot corpses.");
			if(skapi.KeyState(Pause)) skapi.Keys(Pause); // Pause tank
			TaskAdd(OnCommand,"loot",0,0,0);
		}
		return;
	}
	if(aTime.cmsec<3000) return; // Are we idle yet?
	aco= skapi.acoSelected;		// Target selected?
	if(aco && (aco.ocm&ocmMonster)) { // Resume attack?
		CombatMode(true);		// Make sure we are in combat mode
		skapi.Keys(cmidLowAttack);
		Target= skapi.acoSelected;
	} else TaskAdd(DoTarget,0,0,evidOnActionComplete,500); // Aquire a new target
	aTime.cmsec= 0;			// Reset action timer
}

function DoLoot() {		// Loot corpses
	var Filter= skapi.AcfNew();	// Init corpse filter
	Filter.distMax= Range;		// Max distance to check
	var dz, cnt= Corpses.Count;	// List size
	var myloc= skapi.maplocCur;	// Get my current location
	skapi.SetControlProperty(Title,"piCmd","value",100-cnt*100/MaxCnt);
	while(Looting && Action==DoLoot) { // Make sure looting hasn't been interrupted
		var aco= Filter.AcoGetSorted(skapi.sortbyDist,Corpses); // Find nearest
		if(!aco) break;			// No match found?
		if(!aco.fExists || Opened[aco.oid]) { // Already opened?
			Corpses.RemoveAco(aco); // Remove from list
			if(Log) Msg(aco.szName+" has already been opened.");
			skapi.SetControlProperty(Title,"piCmd","value",100-(--cnt)*100/MaxCnt);
			continue;
		}
		if(!LootAll) {			// Just loot our corpses?
			if(Assess(aco)) NextCorpse= aco; // Assess if needed
			else if(aco.oai.ibi.szDescDetailed!=KilledByMe) { // Is it my kill?
				Corpses.RemoveAco(aco); // Remove from list
				if(Log) Msg(aco.szName+" wasn't my kill.");
				skapi.SetControlProperty(Title,"piCmd","value",100-(--cnt)*100/MaxCnt);
				continue;
			}
		}
		var dz= Math.abs(aco.maploc.z - myloc.z); // Vertical distance
		if(!myloc.fInDungeon) dz -= 200*myloc.Dist2DToMaploc(aco.maploc);
		if(aco==NextCorpse || dz>3) {	// Did we already try this one?
			Corpses.RemoveAco(aco); // Remove from list
			HoldCorpses.AddAco(aco); // Add to hold list
			skapi.SetControlProperty(Title,"piCmd","value",100-(--cnt)*100/MaxCnt);
			continue;
		}
		GetObject(NextCorpse= aco);	// Remember what we're trying
		WaitFor= evidOnOpenContainer;
		if(One) Action= null;	// Single target?
		return;
	}
	if(Gnd && GndLoot.Count) {	// Get loot on ground?
		Contents= GndLoot;		// Get current loot list
		CCnt= GndLoot.Count;	// # of items to check
		LootCnt= 0;				// Reset loot counter
		if(Log) Msg("Checking "+CCnt+" loot items on the ground.");
		GndLoot= skapi.CoacoNew();	// Empty loot collection
		TaskAdd(DoContents,0,CCnt,0,0); // Process the loot
		return;
	}
	if(Action==DoLoot) {		// Was looting still active?
		Action= null;			// Clear current action
		Msg("Looting "+(Looting ? "completed" : "stopped"));
		if(!Looting) return;	// Stop?
		skapi.SetControlProperty(Title,"piCmd","value",100);
		if(AutoS && Salvage.Count) TaskAdd(OnCommand,"salvage loot",0,0,0); // Salvage?
		if(!Auto) return;		// Look for something else to do?
		else Action= FindTarget; // Can we find something to kill?
	}
}

function DoSellFish() {			// Turn in fish we caught
	if(FishC.Count<1) {
		Action= null;			// Clear the current action
		Msg(FmtNbr(Cost)+" fish sold for a total of "+FmtNbr(Val));
		return;
	}
	if(!GM) {Msg("You aren't by the Tackle Master."); return;}
	var aco= FishC(0);			// Get the next fish
	Msg("Giving "+aco.szName);
	if(aco.citemStack>1) {	// Is this a stack?
		skapi.SelectAco(aco); // Make sure its selected
		skapi.Keys(cmidSplitSelected+"1\n"); // Set the buy count
		skapi.WaitEvent(100,wemFullTimeout); // Give it time to finish
	} else FishC.RemoveAco(aco); // Remove from list
	if(Task.first) return;
	aco.MoveToStack(GM);	// Give the token
	skapi.WaitEvent(2000,wemSpecific,evidOnAddToInventory); // Wait for cash
	if(Target==aco) return;	// Repeating a give?
	Cost += aco.cpyValue;	// Count the cost of what we're giving
	Target= aco;			// Remember the last token
}

function DoToken() {	// Turn in casino tokens
	var ttype, Filter, wait;
	var aco= skapi.AcoFindInInv("* Gambling Token"); // Find a token
	if(!aco) {
		Action= null;				// Clear the current action
		Msg("All tokens used, Cost="+Cost/1000+"k, Value received="+FmtNbr(Val));
		return;
	}
	ttype= aco.szName.split(" ")[1]; // Get token type
	if(ttype!=GMtype) {		// Have we found a gamemaster?
		Filter= skapi.AcfNew();	// Init filter
		Filter.szName= "* "+ttype+" *";	// Find gamemaster
		Filter.olc= olcOnGround; // Only look in environment
		Filter.distMax= 0.3;	// Must be on radar
		GM= Filter.AcoGetSorted(skapi.sortbyDist); // Find the nearest one
		if(!GM) {Msg("No "+ttype+" gamemaster found."); return;}
		Msg("Approaching "+ttype+" gamemaster.");
		GMtype= ttype;		// Remember current type
		wait= 7000;			// Extra wait the first time
	} else wait= 4000;
	Msg("Giving "+ttype+" token.");
	if(aco.citemStack>1) {	// Is this a stack?
		skapi.SelectAco(aco); // Make sure its selected
		skapi.Keys(cmidSplitSelected+"1\n"); // Set the buy count
		skapi.WaitEvent(100,wemFullTimeout); // Give it time to finish
	}
	if(Task.first) return;
	aco.MoveToStack(GM);	// Give the token
	skapi.WaitEvent(wait,wemSpecific,evidOnAddToInventory); // Wait for prize
	if(Target==aco) return;	// Repeating a give?
	Cost += aco.cpyValue;	// Count the cost of what we're giving
	Target= aco;			// Remember the last token
}

function FindNext(NPC) { // Find an NPC to attack
	var aco, dz, myloc= skapi.maplocCur; // Get my current location
	NPC.Sort(skapi.sortbyDist);			// Try the closest ones first
	while(NPC.Count) {					// Check monsters found
		aco= NPC(0);					// Get a target
		dz= Math.abs(aco.maploc.z - myloc.z); // Vertical distance
		if(!myloc.fInDungeon) dz -= 200*myloc.Dist2DToMaploc(aco.maploc);
		if(dz<3) return aco;			// Skip if too far up or down
		NPC.RemoveAco(aco);				// Remove from collection
	}
	return null;
}

function FindTarget() {	// Look for a target to attack
	if(Home) {						// Do we have a home location?
		var dist= skapi.maplocCur.Dist3DToMaploc(Home); // Get distance
		var walk= dist<.05;			// In walking distance?
		if(skapi.maplocCur.fInDungeon) dist *= 3; // Scale in dungeon
		if(dist>.03) {				// Are we too far away?
			Msg("Returning to home position.");
			skapi.GoToMaploc(Home,walk?.002:.01,walk); // Go home
			Nav= 2;						// Indicate navigation in progress
			skapi.WaitEvent(20000,wemSpecific,evidOnNavStop); // Wait for it to complete
		}
		if(skapi.maplocCur.fInDungeon) skapi.TurnToHead(Home.head);
	}
	if(!Find || skapi.maplocCur.fInDungeon) { // Skip in dungeon
		if(Tank) {
			CombatMode(false);		// Make sure we are in combat mode
			Msg("Returning control to Tank.");
			Action= DoKill, aTime.cmsec= 0; // Init kill mode
			if(!skapi.KeyState(Pause)) skapi.Keys(Pause); // Unpause tank
		} else Action=null;
		return;
	}
	Msg("Looking for a target...");
	skapi.Keys(cmidReady), IgnoreS=true; // Make sure we're not running
	var aco, NPC= skapi.CoacoFromOcm(ocmMonster); // Build monster list
	if(aco=FindNext(NPC)) {				// Find an NPC
		if(Dist3DToMaploc(aco.maploc)>Range) { // Is it out of range?
			if(RunTo(aco,Range)) return; // Run until it is within range
		}
		TaskAdd(OnCommand,"kill",0,0,0); // Switch to kill mode
		return;
	}
	if(Tank) {
		CombatMode(false);			// Make sure we are in combat mode
		Msg("Returning control to Tank.");
		Action= DoKill, aTime.cmsec= 0; // Init kill mode
		if(!skapi.KeyState(Pause)) skapi.Keys(Pause); // Unpause tank
		return;
	} else Msg("No new target found.");
	Action= null;					// We're done
}

// *******
// ******* Task functions start here *******
// *******

function DoContents(aco,cnt) { // Process container contents
	var wait, item, name, val, n=15, i, iei;
	if(!Contents.Count) return;			// Stopped?
	wait= cnt==Contents.Count ? 2700 : 1800;
	while(cnt-->0) {					// Find an item to process
		if(!Looting || !Contents.Count) return; // Check for a Stop
		if(cnt>=Contents.Count) continue; // Sanity check
		item= Contents(cnt);			// Find the next item
		if(item==null) {Msg("Null item #"+cnt); continue;}
		for(i=n;i;i--) {				// Wait for object creation
			if(name=item.szName) break;	// Is the name valid yet?
			skapi.WaitEvent(100,wemFullTimeout); // Wait a bit longer
		}
		if(!name) {Msg("Null name on item #"+cnt+", "+item.oid.toString(16)); continue;}
		if(!aco) {						// Ground item?
			var dist= skapi.maplocCur.Dist2DToMaploc(item.maploc); // Get distance
			if(Log) Msg(item.szName+" range is "+Math.round(dist*100));
			if(dist>Range) continue;	// Skip if out of range
			wait= 2000+dist/skapi.vRun*1100; // Time to run there
		}
		var val= item.cpyValue, desc="";
		if(Log) Msg("Found "+name+", Value="+val);
		var word = name.split(" ");		// Split name into words
		var nbr= item.citemStack;
		var waitType= item.citemMaxStack>nbr ? evidOnAdjustStack : evidOnAddToInventory;
		if(word[1]=="Scarab") {			// Is it a scarab?
			if(ScarabName[word[0]]<Scarab) continue; // Is this too low a scarab to loot?
			TaskAdd(DoMove,item,Pack.Scarab,evidOnAdjustStack,wait);
			desc= " (scarab)";	// Add a description
			break;
		}
		if(Loot[name] || LootName.test(name)) { // Is this a desired loot item?
			TaskAdd(DoMove,item,-2,waitType,wait);
			desc= " (name)";	// Add a description
			break;
		}
		if(Eat && (item.oty&otyFood)) {	// Eat food or drink item?
			if(name.indexOf("Mana ")>=0) {
				if(skapi.manaCur<skapi.SkinfoFromVital(vitalManaMax).lvlCur*EatP/100)
						desc= " (eat mana)"; // Add a description
			} else if(name.indexOf("Health")>=0 || name.indexOf("Healing")>=0) {
				if(skapi.healthCur<skapi.SkinfoFromVital(vitalHealthMax).lvlCur*EatP/100)
						desc= " (eat health)"; // Add a description
			} else if(skapi.staminaCur<skapi.SkinfoFromVital(vitalStaminaMax).lvlCur*EatP/100)
						desc= " (eat stamina)"; // Add a description
			if(desc) {			// Did we find something to eat?
				TaskAdd(DoMove,item,-1,evidOnAddToInventory,wait);
				break;
			}
		}
		if(Elixirs&ElixirName[name]) { // Save this elixir/potion?
			TaskAdd(DoMove,item,Pack[name],evidOnAdjustStack,wait);
			desc= " (potion)";	// Add a description
			break;
		}
		if(word[0]=="Scroll") {			// Is this a scroll?
			if(!Scroll) continue;		// Ignore scrolls?
			var spell= skapi.SpellInfoFromSpellid(item.spellid);
			if(spell.diff/50+1 < Scroll) continue; // Is this too low a scroll to loot?
			if(Check && CheckScroll(item.spellid,true)) continue; // Unusable?
			TaskAdd(DoMove,item,0,evidOnAddToInventory,wait);
			var lvl= spell.diff/50+1;
			desc= " (scroll lvl="+lvl+")"; // Add a description
			break;
		}
		if(Tusk && (word[2]=="Tusk" || word[2]=="Pincer")) { // Pick up a tusk/pincer?
			SetCtlCheck("cbTusk",Tusk=false); // Only pick up one
			TaskAdd(DoMove,item,0,waitType,wait);
			desc= " (quest)";		// Add a description
			break;
		}
		if(Assess(item)) continue;	// Assess if needed
		if(iei=item.oai.iei) {		// Does it have spells?
			n= iei.cspellid;		// # of spells on this object
			while(n--) {			// Check all of the spells
				spname= skapi.SzFromSpellid(i=iei.rgspellid(n)); // Get the spell name
				i= spname.slice(0,5); // Spell prefix
				if(i=="Major" || (Cantrip && i=="Minor")) { // Got cantrip?
					TaskAdd(DoMove,item,-2,waitType,wait);
					desc= " (spell="+spname+")"; // Add a description
					break;
				}
			}
			if(desc) break;			// Did we find one?
		}
		if(Armor && (item.mcm&mcmArmor)) {	// Is it armor?
			n= item.oai.iai.al;		// Getthe AL
			if(n>=Armor) {			// Is it good enough?
				TaskAdd(DoMove,item,-2,waitType,wait);
				desc= " (AL="+n+")"; // Add a description
				break;
			}
		}
		if(item.mcm&mcmWeapon) {	// Is it a weapon?
			var type= WeaponID[item.oai.iwi.skid];	// Weapon skill type
			if(type && (n=Weapons[type])) { // Is it a type we check?
				if(item.mcm&mcmWeaponsMelee) dmg= item.oai.iwi.dhealth;
				else dmg= Math.round((item.oai.iwi.scaleDamageBonus-1)*100);
				if(dmg>=n) {		// Is it good enough?
					TaskAdd(DoMove,item,-2,waitType,wait);
					desc= " (damage="+dmg+")"; // Add a description
					break;
				}
			}
		}
		var code= item.oai.ibi.material, work= item.oai.ibi.workmanship;
		if(MtlCode[code] && work>=MtlCode[code]) { // Salvage?
			TaskAdd(DoMove,item,-2,waitType,wait);
			Salvage.AddAco(item);		// Add it to salvage collection
			desc= " (workmanship="+work+")"; // Add a description
			break;
		}
		var rat= val/item.burden;		// Value/weight ratio
		if(val>=Value && rat>Ratio) {	// Is it good-value loot?
			TaskAdd(DoMove,item,-2,waitType,wait);
			desc= " ("+val+"p, "+item.oai.ibi.burden+"bu)"; // Add a description
			break;
		}
	}
	if(cnt>=0) {						// Did we select something?
		var str= nbr>1 ? nbr+" " : "";	// Add a count for multiple items
		if(nbr>1) name+= "s";			// Make plural?
		LootCnt++;						// Increment loot counter
		Msg("Looting "+str+name+desc);
	}
	if(cnt<1) {							// Last item in container?
		if(aco) {						// was this really a container?
			if(aco.ocm & ocmMonsterCorpse) Opened[aco.oid]= true; // Remember corpses opened
			if(Corpses.FContainsAco(aco)) Corpses.RemoveAco(aco); // Remove from list
		}
		Msg("Looted "+LootCnt+"/"+CCnt+" items.");
		Contents= skapi.CoacoNew();		// Empty container contents collection
	} else TaskAdd(DoContents,aco,cnt,0,0); // Process the contents
}

function DoDrop(aco,target) { // Drop an object
	aco.Drop();
	if(Log) Msg("Dropping "+aco.szName);
}

function DoMove(aco,pack) {	// Move an object
	if(pack==-1) aco.MoveToPack(0,0,false);	// Move it to main pack, no-stack?
	else if(pack==-2) {					// Should we look for a place to put it?
		var stk= null;
		if(aco.citemStack<aco.citemMaxStack) { // Can this item be stacked?
			stk= skapi.AcoFindInInv(aco.szName); // Is there another one?
			if(stk) aco.MoveToContainer(stk.acoContainer); // Stack it
		}
		if(!stk) aco.MoveToPack(0);		// Default to main pack
	} else if(pack==0) aco.MoveToPack(0); // Default is main pack
	else aco.MoveToContainer(pack);	// Move it
	if(Log) {
		var cnt= aco.citemStack;
		var str= cnt>1 ? cnt+" " : "";	// Add a count for multiple items
		Msg("Moving "+str+aco.szName);
	}
}

function DoStack(aco,target) {	// Stack an object
	aco.MoveToStack(target); // Merge with stack
	if(Log) Msg("Stacking "+aco.szName);
}

function DoStop(all,msg) {		// Stop selected actions
	if(Nav>0) {				// Is a GoTo in progress?
		skapi.CancelNav();	// Cancel Navigation
		Nav= -1;			// Reset the flag
		Msg("Go stopped");
		if(!Action) return true;
	}
	Task.first= Task.last= 0;	// Cancel any pending tasks
	Contents= skapi.CoacoNew();	// Empty container contents collection
	if(buyCnt) buyCnt= 0;		// Cancel buy?
	else if(Contents.Count) Contents.Count= 0; // Looting container?
	else if(!Action) return false;
	if(Action==DoLoot) Msg("Looting stopped"+msg);
	else if(Action==FindTarget) Msg("Find stopped");
	else if(Action==DoFish) Msg("Fishing stopped");
	else if(Action==DoSellFish) Msg("Fish selling stopped");
	else if(Action==DoToken) Msg("Token stopped");
	else if(Action==DoKill) {
		if(!all) return false;
		Msg("Killing stopped");
	}
	if(Auto && !msg) {				// Auto on?
		SetCtlCheck("cbAuto",Auto=false); // Clear the control check box
		Msg("Auto activity selection disabled.");
	}
	skapi.CancelNav(), IgnoreS=true; // Make sure we've stopped our action
	Action= null;
	return true;
}

function DoTarget() {			// Aquire a new target
	var Filter= skapi.AcfNew();	// Init target filter
	Filter.distMax= Range;		// Max distance to check
	Filter.ocm= ocmMonster;		// Look for monsters
	var NPC= Filter.CoacoGet(); // Build monster list
	if(!(aco=FindNext(NPC))) {	// Find an NPC
		Msg("No targets left in range.");
		Action= null;
		if(Auto) TaskAdd(OnCommand,"loot",0,0,0); // Switch modes?
		return;
	}
	var cnt= NPC.Count;			// Count how many
	if(cnt>MaxCnt) MaxCnt= cnt;	// Update count?
	if(Auto && Looting && !Attacker && Corpses.Count && Weapon==eqmWeapon &&
			Dist3DToMaploc(aco.maploc)>MaxCharge) {
		Msg("Pausing to loot corpses.");
		Action= null;
		TaskAdd(OnCommand,"loot",0,0,0); // Start looting
		return;
	}
	CombatMode(true);			// Make sure we are in combat mode
	aTime.cmsec= 0;				// Reset action timer
	if(Tank) {					// Let Tank handle the attacks?
		if(!skapi.KeyState(Pause)) skapi.Keys(Pause); // Unpause tank
		return;
	}
	// Note: For melee attack, we must run to target if out of charge range
	if(Weapon==eqmWeapon && Dist3DToMaploc(aco.maploc)>MaxCharge) {
		if(RunTo(aco,MaxCharge)) return; // Check for run stop
	}
	skapi.SelectAco(Target=aco); // Select new target
	skapi.WaitEvent(200,wemFullTimeout); // Wait for stability
	skapi.Keys(cmidLowAttack);	// Initiate next attack
	Msg("Attacking "+Target.szName);
	MissCnt= 0;					// Reset miss count
	if(One) Action= null;		// Single target?
}

function DoUse(aco,target) {	// Use an object
	if(target) aco.UseOnAco(target);
	else aco.Use();
}

function TaskAdd(func,aco,arg,wait,time) { // Add a new tast to the list
	Task[++Task.last]= {func:func, aco:aco, arg:arg, wait:wait, time:time};
	if(!Task.first) Task.first= Task.last; // Activate list if empty
}

function TaskDo() {			// Do the next tast in the list
	var t= Task.first;		// Get the next task #
	if(t>Task.last) Task.first= Task.last= t= 0; // Last task?
	if(t) {					// Got a queued task?
		Task[t].func(Task[t].aco,Task[t].arg); // Do the task
		WaitFor= Task[t].wait;
		WaitTime= Task[t].time;
		Task.first++;		// Advance pointer
		return;
	}
	if(Action) Action();			// Continue an action?
}

// ***** Event handler functions start here *****

// Function to set up event handlers
function DefineHandlers() {
	skapi.AddHandler(evidOnActionComplete, handler);
	skapi.AddHandler(evidOnAddToInventory, handler);
	skapi.AddHandler(evidOnAdjustStack, handler);
	skapi.AddHandler(evidOnApproachVendor, handler);
//	skapi.AddHandler(evidOnAssessCreature, handler);
//	skapi.AddHandler(evidOnAssessItem, handler);
	skapi.AddHandler(evidOnChatServer, handler);
	skapi.AddHandler(evidOnChatSpell, handler);
	skapi.AddHandler(evidOnCommand, handler);
	skapi.AddHandler(evidOnControlEvent, handler);
	skapi.AddHandler(evidOnControlProperty, handler);
	skapi.AddHandler(evidOnDeathMessage, handler);
	skapi.AddHandler(evidOnEnd3D, handler);
	skapi.AddHandler(evidOnFellowCreate, handler);
	skapi.AddHandler(evidOnHotkey, handler);
	skapi.AddHandler(evidOnLeaveVendor, handler);
	skapi.AddHandler(evidOnMeleeDamageOther, handler);
	skapi.AddHandler(evidOnMeleeEvadeOther, handler);
	skapi.AddHandler(evidOnMeleeLastAttacker, handler);
	skapi.AddHandler(evidOnNavStop, handler);
	skapi.AddHandler(evidOnObjectCreate, handler);
	skapi.AddHandler(evidOnObjectDestroy, handler);
	skapi.AddHandler(evidOnOpenContainer, handler);
	skapi.AddHandler(evidOnSpellFailSelf, handler);
	skapi.AddHandler(evidOnStatSkillExp, handler);
	skapi.AddHandler(evidOnStatTotalExp, handler);
	skapi.AddHandler(evidOnStatUnspentExp, handler);
	skapi.AddHandler(evidOnTimer, handler);
	skapi.AddHandler(mtyAllegianceInfo, handler);
	skapi.AddHandler(mtyOnMemberLogin, handler);
}

// Function to remove event handlers
function RemoveHandlers() {
	skapi.RemoveHandler(evidOnActionComplete, handler);
	skapi.RemoveHandler(evidOnAddToInventory, handler);
	skapi.RemoveHandler(evidOnAdjustStack, handler);
	skapi.RemoveHandler(evidOnApproachVendor, handler);
//	skapi.RemoveHandler(evidOnAssessCreature, handler);
//	skapi.RemoveHandler(evidOnAssessItem, handler);
	skapi.RemoveHandler(evidOnChatServer, handler);
	skapi.RemoveHandler(evidOnChatSpell, handler);
	skapi.RemoveHandler(evidOnCommand, handler);
	skapi.RemoveHandler(evidOnControlEvent, handler);
	skapi.RemoveHandler(evidOnControlProperty, handler);
	skapi.RemoveHandler(evidOnDeathMessage, handler);
	skapi.RemoveHandler(evidOnEnd3D, handler);
	skapi.RemoveHandler(evidOnFellowCreate, handler);
	skapi.RemoveHandler(evidOnHotkey, handler);
	skapi.RemoveHandler(evidOnLeaveVendor, handler);
	skapi.RemoveHandler(evidOnMeleeDamageOther, handler);
	skapi.RemoveHandler(evidOnMeleeEvadeOther, handler);
	skapi.RemoveHandler(evidOnMeleeLastAttacker, handler);
	skapi.RemoveHandler(evidOnNavStop, handler);
	skapi.RemoveHandler(evidOnObjectCreate, handler);
	skapi.RemoveHandler(evidOnObjectDestroy, handler);
	skapi.RemoveHandler(evidOnOpenContainer, handler);
	skapi.RemoveHandler(evidOnSpellFailSelf, handler);
	skapi.RemoveHandler(evidOnStatSkillExp, handler);
	skapi.RemoveHandler(evidOnStatTotalExp, handler);
	skapi.RemoveHandler(evidOnStatUnspentExp, handler);
	skapi.RemoveHandler(evidOnTimer, handler);
	skapi.RemoveHandler(mtyAllegianceInfo, handler);
	skapi.RemoveHandler(mtyOnMemberLogin, handler);
}

// Constructor function for the event handler object.
function EventHandler() {
	this.OnActionComplete = OnActionComplete;
	this.OnAddToInventory = OnAddToInventory;
	this.OnAdjustStack = OnAdjustStack;
	this.OnApproachVendor = OnApproachVendor;
//	this.OnAssessCreature = OnAssessCreature;
//	this.OnAssessItem = OnAssessItem;
	this.OnChatServer = OnChatServer;
	this.OnChatSpell = OnChatSpell;
	this.OnCommand = OnCommand;
	this.OnControlEvent = OnControlEvent;
	this.OnControlProperty = OnControlProperty;
	this.OnDeathMessage = OnDeathMessage;
	this.OnEnd3D = OnEnd3D;
	this.OnFellowCreate = OnFellowCreate;
	this.OnHotkey = OnHotkey;
	this.OnLeaveVendor = OnLeaveVendor;
	this.OnMeleeDamageOther = OnMeleeDamageOther;
	this.OnMeleeEvadeOther = OnMeleeEvadeOther;
	this.OnMeleeLastAttacker = OnMeleeLastAttacker;
	this.OnNavStop = OnNavStop;
	this.OnObjectCreate = OnObjectCreate;
	this.OnObjectDestroy = OnObjectDestroy;
    this.OnOpenContainer = OnOpenContainer;
	this.OnRawServerMessage = OnRawServerMessage;
    this.OnSpellFailSelf = OnSpellFailSelf;
    this.OnStatSkillExp = OnStatSkillExp;
    this.OnStatTotalExp = OnStatTotalExp;
    this.OnStatUnspentExp = OnStatUnspentExp;
    this.OnTimer = OnTimer;
}

// Handler function for the OnActionComplete event.
function OnActionComplete() {
	aTime.cmsec= 0;		// Reset action timer
	if(Log) Msg("Action completed.");
}

// Handler function for the OnAddToInventory event.
function OnAddToInventory(aco) {
	if(Log) Msg("Added to pack: "+aco.szName);
	if(!Looting && Action!=DoToken) return;	// Is Looting disabled?
	if(aco.acoContainer!=Me) return; // Only look at main pack changes
	var word = aco.szName.split(" "); // Split name into words
	if(Action==DoFish) {			// Are we fishing?
		if(word[1]=="Minnow") {		// We don't want minnows
			TaskAdd(DoStack,aco,Hole,evidOnRemoveFromInventory,500); // Return it
			return;
		}
		if(!(aco.oty&otyFood)) {	// Not a fish?
			var value= aco.cpyValue; // Get its value
			if(value<Value) {		// Drop it when its low value
				TaskAdd(DoDrop,aco,0,evidOnRemoveFromInventory,1200);
				return;
			}
		}
	}
	if(Action==DoSellFish) {		// Are we selling fish?
		Cost++;						// Count the # sold
		Val += aco.cpyValue;		// Accumulate the value received
	}
	if(Action==DoToken) {			// Are we receiving casino prizes?
		if(word[3]=="Token") return; // Ignore returned tokens
		var value= aco.cpyValue;	// Get its value
		if(!value) {				// Is it a special item?
		  if(word[2]=="Mnemosyne") value= Mnemosyne[word[1]];
		} else if(word[2]=="Key") value= 50000; // SIK
		else if(word[0]=="Pack") value= 40000; // Pack doll est. value
		Val += value;				// Accumulate the value received
	} else while(Eat && Looting && (aco.oty&otyFood)) { // Eat food?
		var name= aco.szName;		// We need to check the name
		if(name=="Bunch of Nanners") break; // Don't eat the nanners!
		if(name.indexOf("Mana ")>=0) {
			if(skapi.manaCur>skapi.SkinfoFromVital(vitalManaMax).lvlCur*0.9) break;
		} else if(name.indexOf("Health")>=0 || name.indexOf("Healing")>=0) {
			if(skapi.healthCur>skapi.SkinfoFromVital(vitalHealthMax).lvlCur*0.9) break;
		} else if(skapi.staminaCur>skapi.SkinfoFromVital(vitalStaminaMax).lvlCur*0.9) break;
		TaskAdd(DoUse,aco,0,evidOnActionComplete,1500); // Eat/drink the item?
		return;
	}
	if(aco.eqm==eqmAmmo) {			// Is it Ammo?
		slot= skapi.AcoFromEqm(eqmAmmo); // Ammo slot
		if(slot!=null && aco.szName==slot.szName) { // Is it the current ammo type?
			TaskAdd(DoStack,aco,slot,evidOnAdjustStack,500); // Move to ammo slot
			return;
			}
		}
	if(word[1]=="Scarab" || word[0]=="Prismatic") { // Scarabs or P.tapers?
		if(Pack.Scarab>0) {		// Don't check for move if no destination
			TaskAdd(DoMove,aco,Pack.Scarab,evidOnAdjustStack,500);
			return;
		}
	}
	if(aco.citemStack<aco.citemMaxStack) { // Can this item be stacked?
		var stk= skapi.AcoFindInInv(aco.szName,aco); // Is there another one?
		if(stk && stk.citemStack<stk.citemMaxStack) { // Not full?
			TaskAdd(DoStack,aco,stk,evidOnAdjustStack,500); // Stack it
		}
	}
	if(Me.citemContents==Me.citemMax) { // Main pack full?
		Msg("Main pack full, looting disabled.");
		Looting= false;
		SetCtlCheck("cbLoot",Looting); // Switch the control check box
		if(Action==DoToken) Action= 0; // Stop handing in tokens?
		return;
	}
}

// Handler function for the OnAdjustStack event.
function OnAdjustStack(aco,cnt) {
	if(aco.acoContainer!=Me) return;	// Only look at main pack changes
	var sz= aco.citemStack;			// New stack size
	if(sz<cnt) return;				// Ignore splits
	if(Log) Msg("Merged: "+aco.szName+"("+(sz-cnt)+")");
}

// Handler function for the OnApproachVendor event.
function OnApproachVendor(acoMerchant,mcmBuy,cpyMaxBuy,fractBuy,fractSell,coaco) {
	Vendor= {};
	Vendor.aco= acoMerchant;			// Vendor object
	Vendor.buys= mcmBuy;				// Buy categories
	Vendor.max= cpyMaxBuy;				// Maximum buy price
	Vendor.buypct= fractBuy;			// The percent of list price paid
	Vendor.sellpct= fractSell;			// The selling markup
	Vendor.stock= coaco;				// List of vendor's stock
}

// Handler function for the OnChatServer event.
function OnChatServer(msg,color) {
	if(Log) Msg("Server Message: '"+msg+"', color="+color);
	if(msg.indexOf(" logged ")>1) DecodeFriends(msg); // Store login?
	if(Action==DoFish) {		// Are we fishing?
		var word= msg.split(" ");
		switch(word[1]) {		// What was the result?
		case 'catch': tTime.cmsec= -700; break;
		case 'catch...':
		case 'fail': tTime.cmsec= -600; break; // Try again
		case 'need': Action=null; break;	// No license
		case 'pull': tTime.cmsec= -600; break; // Caught junk
		default: return;
		}
	}
	if(msg!="Your missile attack hit the environment.") return;
	if(Action!=DoKill) return;	// Are we automated?
	if(++MissCnt<4) return;		// Repeated misses?
	skapi.Keys(cmidReady), IgnoreS=true; // Stop our current action
	Msg("Shooting stopped due to repeated misses.");
	if(Attacker && Target!=Attacker) { // Do we have another target?
		skapi.SelectAco(Target=Attacker); // Select new target
		Msg("Attacking "+Target.szName);
		MissCnt= 0;				// Reset miss count
		return;
	}
	Action= null;				// Cancel attack
	if(Auto) TaskAdd(OnCommand,"loot",0,0,0); // Switch modes?
}

// Handler function for the OnChatSpell event.
function OnChatSpell(aco,msg) {
	if(aco==Me && Tank) aTime.cmsec= 0; // Reset action timer if Tank is casting
}

// Handler function for the OnCommand event.
function OnCommand(cmd) {
	word = cmd.split(" ");
	switch(word[0]) {
	case "all":		// Toggle looting all corpses
		LootAll= !LootAll;
		SetCtlCheck("cbAll",LootAll); // Switch the control check box
		Msg("Looting all corpses is "+(LootAll ? "on" : "off"));
		break;
	case "armor":	// Display/set the armor level
		if(word.length>1) {			// Just display list?
			nbr= parseInt(word[1]);		// Get armor level
			if(isNaN(nbr) || nbr<0) {Msg("armor level should be >=0"); break;}
			Armor= nbr;					// Set the armor level
		}
		if(Armor) Msg("Looting armor of level "+nbr+" or better.");
		else Msg("Armor looting has been disabled.");
		break;
	case "auto":	// Toggle auto activity selection
		Auto = !Auto;
		SetCtlCheck("cbAuto",Auto); // Switch the control check box
		Msg("Auto activity selection is "+(Auto ? "on" : "off"));
		break;
	case "buy":		// Buy tokens
		if(!Vendor) {Msg("No vendor window open to buy from."); break;}
		var aco= skapi.acoSelected; // Get the current selection
		if(!Vendor.stock.FContainsAco(aco)) aco=null; // Vendor item selected?
		if(aco && aco.szName.split(" ")[3]!="Token") aco=null; // Must be a token
		if(!aco) {Msg("Select the token to buy."); break;}
		var name= aco.szName;		// Token name
		var cost= aco.cpyValue; 	// Token price
		if(word.length>1) {			// Is a buy count given?
			buyCnt = parseInt(word[1]);
			if(isNaN(buyCnt) || buyCnt<1) {Msg("Buy count should be >0"); break;}
			if(buyCnt*cost>skapi.cpyCash) {Msg("You can't afford that many"); break;}
		} else buyCnt= Math.floor(skapi.cpyCash/cost); // The # of tokens we can afford
		if(cnt<1) {Msg("You don't have enough pyreals to buy any."); break;}
		var free= Me.citemMax - Me.citemContents; // # of free pack slots
		if(free<1) {Msg("You don't have enough space to buy any."); break;}
		Msg("Buying "+buyCnt+" tokens.");
		if(buyCnt>1) {				// Buying more than 1?
			skapi.Keys(cmidSplitSelected+buyCnt+"\n"); // Set the buy count
			skapi.WaitEvent(100,wemFullTimeout); // Give it time to finish
		}
		skapi.MouseMove(-342,ChatSize(-166)); // Move mouse to Buy button
		skapi.MouseButton(ibuttonLeft); // Click the left button
		skapi.WaitEvent(3000,wemSpecific,evidOnAddToInventory); // Wait for token
		break;
	case "cantrip":		// Toggle looting minor cantrips
		Cantrip = !Cantrip;
		Msg("Minor cantrip looting is "+(Cantrip ? "on" : "off"));
		break;
	case "carve":	// Carve golem hearts
		if(!skapi.SklvlUnbuffedFromSkid(skidLockpick)) {
			Msg("Lockpick skill is required for carving."); break;}
		var tool= skapi.AcoFindInInv("Intricate Carving Tool");
		if(!tool) {Msg("An Intricate Carving Tool is required for carving."); break;}
		var Filter= skapi.AcfNew();	// Init heart filter
		Filter.szName= "* Heart";	// Only check for Hearts
		Filter.olc= olcInventory;	// Only my inventory
		Filter.mcm= mcmMisc;		// Valid heats are misc. type
		var Hearts= Filter.CoacoGet(); // Scan for hearts
		var n, cnt=Hearts.Count;
		if(!cnt) {Msg("No hearts found to carve."); break;}
		Msg("Carving "+cnt+" hearts...");
		while(cnt--) {
			var aco= Hearts(cnt);	// Get the next heart
			for(n=4;aco.fExists && n--;) { // Repeat until it works
				tool.UseOnAco(aco);	// Carve the heart
				skapi.WaitEvent(900,wemSpecific,evidOnActionComplete); // Wait for completion
				skapi.WaitEvent(500); // Give it some extra time
			}
			if(n<0) Msg("Couldn't carve "+aco.szname);
		}
		Msg("Carving completed.");
		break;
	case "chars":	// List characters in the configuration
		var str="", cnt, name;
		for(cnt=Char[0];cnt;cnt--) {	// List all defined characters
			name= Char[cnt];			// Get the next name
			if(str!="") str += ", ";
			str += name;				// Add name to list
		}
		Msg("Configured chars: "+str);
		break;
	case "chat":	// Toggle logging to chat
		if(word.length>1) {
			Chat= word[1];
		} else Chat= !Chat;
		Msg("Chat logging is "+(Chat ? "on" : "off"));
		break;
	case "check":	// Check a scroll's usability
		if(word.length>1) {
			if(word[1]!="loot") {Msg("Invalid option, "+word[1]); break;}
			Check= !Check;				// Toggle the value
			Msg("Loot scroll checking is "+(Check ? "on" : "off"));
			break;
		}
		var aco= skapi.acoSelected;
		if(!aco) {Msg("Nothing is selected."); break;}
		var spid = aco.spellid;			// Get the associated spell
		if(!spid) {Msg("'"+aco.szName+"' is not a scroll."); break;}
		var diff= CheckScroll(spid).diff;
		Msg("Spell difficulty= "+diff);
		break;
	case "corpses":	// List corpses to loot
		var cnt= Corpses.Count;		// List size
		if(cnt<1) {Msg("No corpses left to loot."); break}
		Msg("Current list of corpses("+cnt+"):");
		var myloc= skapi.maplocCur;	// My current location
		Corpses.Sort(skapi.sortbyDist); // Sort the list
		var cnt= Corpses.Count;		// List size
		while(cnt--) {
			var aco= Corpses.Item(cnt); // Corpse object
			var dist= 100*myloc.Dist2DToMaploc(aco.maploc); // Distance to corpse
			var str= (aco.oid in Opened) ? (Opened[aco.oid] ? " (o)" : " (u)") : "";
			Msg(aco.szName+", dist="+Math.round(dist)+str);
		}
		break;
	case "cso":		// Display selected object's info
		aco= skapi.acoSelected;
		if(!aco) {Msg("Nothing is selected."); break;}
		var loc= aco.maploc;
		Msg("Loc="+loc+", DgID="+loc.dungid.toString(16)+", Distance="+loc.Dist2DToMaploc(Me.maploc));
		break;
	case "deb":		// Toggle logging detailed messages
		Deb = !Deb;
		Msg("Debug logging is "+(Deb ? "on" : "off"));
		break;
	case "dist":	// Calculate distance to a location
		if(word.length<2) {Msg("Distance to where?"); break;}
		var s,loc= cmd.slice(5);
		if(GoLoc[loc]) loc= GoLoc[loc];	// Try for location string
		var mloc= skapi.MaplocFromSz(loc); // Convert to maploc
		if(!mloc) {Msg("Invalid location, '"+loc+"'."); break;}
		var dist= skapi.maplocCur.Dist2DToMaploc(mloc); // Get distance
		var time= dist/skapi.vRun; // Get run time at current speed
		if(time<90) s= Math.round(time)+" sec";
		else s= (time/60).toFixed(1)+" min";
		var head= Compass(skapi.maplocCur.HeadToMaploc(mloc)); // Get heading
		Msg("Distance to '"+loc+"' is "+dist.toFixed(1)+" "+head+" ("+s+".)");
		break;
	case "eat":		// Set loot eating option
		if(word.length>1) {
			nbr = parseInt(word[1]);
			if(isNaN(nbr) || nbr<1 || nbr>99) {Msg("% must be 1-99"); break;}
			EatP= nbr;				// Save the value
			SetCtlValue("tbEatP",EatP); // Update control value
			Eat= true;
		} else Eat= !Eat;
		SetCtlCheck("cbEat",Eat);	// Switch the control check box
		Msg("Loot eating is "+(Eat ? "on at "+EatP+"%" : "off"));
		break;
	case "eval":	// Display the expression's value
		try {Msg(eval(cmd.slice(5)));}
		catch(err) {Msg("Error during eval: "+err.description);}
		break;
	case "find":	// Toggle finding targets in auto
		Find = !Find;
		Msg("Find mode is "+(Find ? "on" : "off"));
		break;
	case "fish":	// Start fishing
		if(word.length>1) {
			if(word[1]!="sell") {Msg("Unknown option, "+word[1]); break;}
			var Filter= skapi.AcfNew();	// Init filter
			Filter.szName= "Tackle Master";	// Find vendor
			Filter.olc= olcOnGround; // Only look in environment
			Filter.distMax= 0.01;	// Must be very close
			GM= Filter.AcoGet();	// Find the one
			if(!GM) {Msg("You aren't by the Tackle Master."); return;}
			var n= FishName.length;		// Number of name templates
			var fish, acf= skapi.AcfNew();
			acf.olc= olcInventory;		// Only check our inventory
			FishC= skapi.CoacoNew();	// Make an empty collection
			while(n--) {
				acf.szName= FishName[n]; // Get the next name template
				fish= acf.CoacoGet();	// Find matching fish
				FishC.AddCoaco(fish);	// Add to total
			}
			if(FishC.Count<1) {Msg("No fish found to sell."); break;}
			Action= DoSellFish;			// Set current action as selling fish
			Cost= Val= 0, Target= null;	// Init. for value tracking
			break;
		}
		var aco= skapi.AcoFromEqm(eqmWeapons); // See what is equipped
		if(!aco || aco.szName!="Fishing Pole") {
			Msg("You must be wielding a Fishing Pole before you can fish.");
			break;
		}
		var Filter= skapi.AcfNew();	// Init target filter
		Filter.distMax= 0.1;		// Max distance to check
		Filter.szName= "Fishing Hole";	// Look for a fishing hole
		Hole= Filter.AcoGet();		// Try to locate a target
		if(!Hole) {Msg("You aren't close enough to a Fishing Hole."); break;}
		Catch= -1;
		Action= DoFish;
		break;
	case "friends":	// List friends that have been noticed
		var name, friend, cnt=0;
		if(word.length>1) {
			if(word[1]=="add") {
				var aco= skapi.acoSelected;
				if(!aco || !(aco.oty&otyPlayer)) {Msg("No player is selected."); break;}
				MemberID[aco.oid]= aco.szName; // Map ID to name
				Msg(aco.szName+" added for ID:"+Hex(aco.oid));
			} else if(word[1]=="list") { // List allegiance records?
				var id, rec;
				for(id in AllegianceID) { // Process the whole list
					rec= AllegianceID[id]; // Get the member record
					Msg(rec.name+": "+Sex[rec.sex]+", "+Race[rec.race]+", R"+rec.rank+
						", Lead="+rec.leader+", Loy="+rec.loyal+", xp="+rec.xp);
				}
			} else Msg("Undefined option.");
			break;
		}
		for(name in Friends) {		// Process the list
			cnt++;					// Inc. the count
			friend= Friends[name];
			if(friend.on<friend.off) {
				var str= "";		// Default to null
				if(friend.on) {
					var time= (friend.off-friend.on)/60000; // Min. on
					str= " (was on "+time.toFixed(1)+" min.)";
				}
				Msg(name+" has been off since "+ToD(friend.off)+str);
			} else Msg(name+" has been on since "+ToD(friend.on));
		}
		if(!cnt) Msg("No friend logons recorded.");
		break;
	case "get": 	// Get a control setting
		if(word.length<2) {Msg("Get what control?"); break;}
		if(word.length<3) {Msg("Get what control property?"); break;}
		skapi.GetControlProperty(Title,word[1],word[2]);
		break;
	case "go":		// Go to a location
		if(word.length<2) {Msg("Go where?"); break;}
		var s, mloc, loc= cmd.slice(3);
		if(GoLoc[loc]) loc= GoLoc[loc];	// Try for location string
		else if(word.length<3) mloc= null; // Bad format?
		mloc= skapi.MaplocFromSz(loc); // Convert to maploc
		if(!mloc) {Msg("Invalid location, '"+loc+"'."); break;}
		var dist= skapi.maplocCur.Dist3DToMaploc(mloc); // Get distance
		var time= dist/skapi.vRun; // Get run time at current speed
		if(time<90) s= Math.round(time)+" sec";
		else s= (time/60).toFixed(1)+" min";
		Msg("Moving to "+loc+", Dist="+dist.toFixed(2)+", Time="+s);
		skapi.GoToMaploc(mloc,0.005,false,true,time*2000);
		Nav= true;
		break;
	case "hold":	// Check hold corpse list
		var cnt= HoldCorpses.Count; // List size
		Msg("There are "+cnt+" corpses on the hold list.");
		break;
	case "home":	// Set/Clear home location
		if(word.length<2) {		// Set current location?
			Home= skapi.maplocCur; // Get our current map loc.
			Msg("Home location set to current position.");
			break;
		}
		if(word[1]=='clear') {
			Home= null;			// Reset
			Msg("Home location cleared.");
			break;
		}
		var mloc=null, loc= cmd.slice(5);
		if(word.length>2) mloc= skapi.MaplocFromSz(loc); // Convert to maploc
		if(!mloc) {Msg("Invalid location, '"+loc+"'."); break;}
		Home= mloc;
		Msg("Home location set to '"+loc+"'.");
		break;
	case "hot":		// Toggle hot-key usage
		var key;
		Hot = !Hot;
		SetCtlCheck("cbHot",Hot); // Switch the control check box
		for(key in HotKeys) skapi.Hotkey(key,Hot);
		Msg("Hot keys are "+(Hot ? "on" : "off"));
		break;
	case "icon":	// Set icon to display
		if(word.length<2) {Msg("Display what icon?"); break;}
		nbr= parseInt(word[1]);
		if(isNaN(nbr) || nbr<1) {Msg("Icon should be >0"); break;}
		skapi.SetControlProperty(Title,"nbTabs","ActiveTab",3);
		skapi.SetControlProperty(Title,"bTest","Image",nbr);
		break;
	case "id":		// Display selected object's ID
		var aco= skapi.acoSelected;
		if(!aco) {Msg("Nothing is selected."); break;}
		Msg("Selected ID="+Hex(aco.oid)+", icon="+aco.icon+", model="+aco.model);
		Msg("Object type="+aco.oty.toString(16)+", category="+aco.ocm.toString(16));
		Msg("Merchant type="+aco.szMcm+", category="+aco.mcm.toString(16));
		var mloc= aco.maploc;	// Where is it located?
		if(!mloc) break;		// Skip if no location
		var dist= skapi.maplocCur.Dist2DToMaploc(mloc); // Get distance
		Msg("Distance is "+dist.toFixed(3));
		break;
	case "key":		// List or define keys
		if(word.length<2) {		// No argument = list keys
			var key, str= "";
			for(key in HotKeys) {
				if(str!="") str += ", "; // Add separator?
				str += key+"="+HotKeys[key];
			}
			if(str=="") Msg("No hotkeys are defined.");
			else Msg("Defined keys: "+str);
			break;
		}
		if(word.length<3) {		// One argument = delete key
			var key= word[1];
			if(!HotKeys[key]) {Msg("HotKey not defined: "+key); break;}
			if(Hot) skapi.Hotkey(key,false); // Disable the key
			delete HotKeys[key]; // Undefine the key
			Msg("HotKey deleted: "+key);
			break;
		}
		var key= word[1];
		if(key.length!=1) {Msg("HotKeys must be a single key"); break;}
		HotKeys[key]= cmd.slice(6);	// Define the key
		if(Hot) skapi.Hotkey(key,true); // Enable the key
		Msg("HotKey '"+key+"' defined as: '"+HotKeys[key]+"'.");
		break;
	case "kill":	// Start autokilling
		Weapon= skapi.eqmEquipped & eqmWeapons; // Weapon type
		if(!Weapon) Weapon= eqmWeapon; // Default is UA melee
		if(Weapon==eqmFocusWeapon && !Tank) {Msg("Magic attack not supported."); break;}
		var aco= skapi.AcoFromEqm(eqmAmmo); // Check ammo slot
		if(Weapon==eqmRangedWeapon) {	// Ranged attack?
			if(!aco) {Msg("No ammo to shoot."); break;}
			aco= skapi.AcoFromEqm(eqmRangedWeapon); // Get weapon object
			var name=aco.szName, str;
			for (str in Ranged) {		// Check for limited range
				if(name.slice(-str.length)!=str) continue; // Skip if no match
				var rng= Ranged[str]/262.5; // Range in map units
				if(rng<Range) {				// Reduce range to shooting range?
					Range= (rng=Math.floor(rng*100))/100; // Round value down
					SetCtlValue("tbRng",rng); // Update control value
					Msg("Range reduced to weapon range of "+rng);
				}
				break;
			}
		}
		var Filter= skapi.AcfNew();	// Init target filter
//		Filter.distMax= (Weapon==eqmWeapon) ? 0.075 : Range; // Max distance to check
		Filter.distMax= Range;		// Max distance to check
		Filter.ocm= ocmMonster;		// Look for monsters
		aco= Filter.AcoGet();		// Try to locate a target
		if(!aco) {					// Nothing in range?
			Msg("No targets in range to kill.");
			if(Auto) Action= FindTarget; // Can we find something to kill?
			break;
		}
		CombatMode(false);		// Make sure we are in combat mode
		var cnt= Filter.CoacoGet().Count; // Count how many
		Msg("Killing activated for "+cnt+" targets.");
		MaxCnt= cnt;				// Remember the max count
		Action= DoKill, KillCnt= 0; // Init kill mode
		skapi.SetControlProperty(Title,"piCmd","value",0);
		TaskAdd(DoTarget,0,0,evidOnActionComplete,500); // Aquire a new target
		break;
	case "list":	// List all scroll usage
		var name, mask=0, nbr=0, skill; // Default to no selection mask
		if(word.length>1) {
			name= cmd.slice(5);		// Get name to check
			mask= Char[name];		// Get skill bits
			if(!mask) {Msg("'"+name+"' isn't configured."); break;}
			skill= mask & 15;		// Get the magic skill types
			mask &= -16;			// Get the selection bit
		}
		var Filter= skapi.AcfNew();	// Init scroll filter
		Filter.szName= "*Scroll *"; // Check for scrolls including varients
		var aco= skapi.acoSelected;
		if(aco && (aco.oty & otyContainer)) { // Container selected?
			var coaco= aco.coacoContents; // Get current container contents
			var Scrolls= Filter.CoacoGet(coaco); // Scan for scrolls
		} else {					// Default to inventory
			Filter.olc= olcInventory;	// Only my inventory
			var Scrolls= Filter.CoacoGet();	// Scan for scrolls
		}
		var bits, spid, cnt= Scrolls.Count;
		if(!cnt) {Msg("No scrolls found to list."); break;}
		if(mask) Msg("Scrolls usable by '"+name+"':");
		while(cnt--) {				// List all the found scrolls
			spid=  Scrolls.Item(cnt).spellid; // Get spell id
			if(!spid) continue;		// Skip if not valid
			if(mask) {				// Filter scrolls by mask?
				bits= Spell[spid];		// Get spell mask bits
				if(!bits) bits= AddSpell(spid); // Add spell if not known
				if(bits&mask) continue; // Skip if known
				if(bits&skill) Msg(skapi.SzFromSpellid(nbr=spid));
			} else CheckScroll(spid); // List the scroll
		}
		if(mask && !nbr) Msg("(None found)");
		break;
	case "loc": 	// Display current location
		Msg("Current location: "+skapi.maplocCur.sz(3));
		break;
	case "locate":		// Locate an object by name
		if(word.length<2) {Msg("Locate what?"); break;}
		var name= cmd.slice(7); // Get object name
		var aco= skapi.AcoFromSz(name); // Try to find the name
		if(!aco) {Msg("Unable to locate '"+name+"'."); break;}
		skapi.SelectAco(aco);	// Select the object
		var mloc= aco.maploc;
		if(!mloc) {Msg(aco.szName+" is selected."); break;}
		var dist= skapi.maplocCur.Dist2DToMaploc(mloc); // Get distance
		var head= Compass(skapi.maplocCur.HeadToMaploc(mloc)); // Get heading
		Msg(aco.szName+" is "+dist.toFixed(2)+" "+head);
		break;
	case "log":		// Toggle logging detailed messages
		Log = !Log;
		Msg("Logging is "+(Log ? "on" : "off"));
		break;
	case "loot":	// Start autolooting or edit loot list
		if(word.length>1) {
			var name="", aco=skapi.acoSelected;;
			if(word.length>2) name= cmd.slice(9); // Get loot name
			else if(aco) name= aco.szName; // Use selected object name?LootAttack
			switch(word[1]) {	// Modify loot list?
			case "add":				// Add an item to the loot list
				if(!name) {Msg("No object selected to add."); break;}
				Loot[name]= true;	// Add name
				Msg("Added '"+name+"' to loot list.");
				break;
			case "attack":			// Toggle loot during attack
				LootAttack= !LootAttack; // Toggle flag
				Msg("Looting during attack is "+(LootAttack ? "on" : "off"));
				break;
			case "ground":			// Toggle loot on ground
				Gnd= !Gnd; // Toggle flag
				Msg("Looting on ground is "+(Gnd ? "on" : "off"));
				break;
			case "list":			// Display the loot list
				var str="";
				for(name in Loot) str += (str?", ":"")+name; // Build name list
				Msg("Loot names: "+str);
				break;
			case "rem":				// Remove an item from the loot list
				if(!name) {Msg("No object selected to remove."); break;}
				if(!Loot[name]) {Msg(name+" isn't being looted."); break;}
				delete Loot[name];	// Remove name
				Msg("Removed '"+name+"' from loot list.");
				break;
			case "save":			// Save the loot list
				cf = fso.OpenTextFile(Title+".loot", ForWriting, true);	// Create file
				cf.WriteLine("// Items to collect as loot. Edit carefully.\n");
				cf.WriteLine("IDwait = "+IDwait+";");
				cf.WriteLine("Loot = "+ObjectToString(Loot,true)+";");
				cf.Close();
				Msg("Loot list saved in '"+Title+".loot'.");
				break;
			case "wait":			// Set/Display the loot wait time
				if(name) {			// Do we have a new wait time?
					nbr= parseInt(name); // Get the time
					if(nbr<1000) {Msg("Minimum wait time is 1000ms."); break;}
					IDwait= nbr;	// Set new wait time
				}
				Msg("Loot wait time= "+IDwait+"ms.");
				break;
			default: Msg("Unknown loot command, "+word[1]);
			}
			break;
		}
		if(Me.citemContents==Me.citemMax) { // Main pack full?
			Msg("Main pack full, looting disabled.");
			SetCtlCheck("cbLoot",Looting=false); // Clear the control check box
			break;
		}
		if(!Looting) SetCtlCheck("cbLoot",Looting=true); // Set the control check box
		var aco,cnt;
		Corpses.AddCoaco(HoldCorpses); // Add held list;
		HoldCorpses= skapi.CoacoNew(); // Reset the list
		var Filter= skapi.AcfNew();	// Init corpse filter
		Filter.distMax= Range;		// Max distance to check
		Corpses= Filter.CoacoGet(Corpses); // Filter corpses by distance
		cnt= Corpses.Count;			// List size
		while(cnt--) {				// Pre-check list
			aco= Corpses(cnt);		// Get the next corpse
			if(!aco) continue;		// Sanity check
			if(Opened[aco.oid] || !aco.fExists) Corpses.RemoveAco(aco); // Remove?
		}
		MaxCnt= cnt= Corpses.Count;	// Updated list size
		NextCorpse= null;			// Reset
		if(cnt<1) {					// Nothing to loot?
			if(Gnd && GndLoot.Count>0) {
				MaxCnt= GndLoot.Count;	// Updated list size
				Looting= true;				// Force it on
				Msg("Looting activated for items on the ground.");
				Action= DoLoot;				// Set current action
				break;
			}
			Msg("No corpses left to loot.");
			if(Auto) Action= FindTarget; // Can we find something to kill?
			break;
		}
		if(skapi.fCombatMode) {		// In combat mode?
			if(Tank && skapi.KeyState(Pause)) skapi.Keys(Pause); // Pause tank?
			skapi.Keys(cmidToggleCombat); // Switch to peace mode
			skapi.WaitEvent(900,wemSpecific,evidOnCombatMode); // Wait for it to complete
		}
		Looting= true;				// Force it on
		Msg("Looting activated for "+cnt+" corpses");
		Action= DoLoot;				// Set current action
		break;
	case "looting":	// Toggle looting mode
		Looting= !Looting;
		SetCtlCheck("cbLoot",Looting); // Switch the control check box
		Msg("Looting mode is "+(Looting ? "on" : "off"));
		break;
	case "mat":	// Display/set the material to loot
		if(word.length<2) {			// Just display list?
			var s= "";
			for(name in Material) { // Get all the names
				if(s!="") s += ", "; // Separator needed?
				s += name+"("+Material[name]+")"; // Add the name to the list
			}
			if(s!="") Msg("Looting: "+s);
			else Msg("No materials have been configured for looting.");
			break;
		}
		var nbr= word.length-1;		// The last word #
		var work= parseInt(word[nbr]); // Get workmanship
		if(nbr<2 || isNaN(work)) {
			var name= Caps(cmd.slice(4)); // Get material name
			if(!Material[name]) {Msg("'"+name+"' isn't configured."); break;}
			delete Material[name];	// Delete it from the list
			delete MtlCode[MtlName[name]];
			Msg("'"+name+"' removed from material configuration.");
			break;
		}
		if(work<1 || work>9) {Msg("Workmanship should be 1-9"); break;}
		var name= Caps(cmd.slice(4,cmd.length-2)); // Get material name
		var code= MtlName[name];	// Get the code for this name
		if(!code) {Msg("'"+name+"' isn't a recognized material."); break;}
		MtlCode[code]= Material[name]= work; // Add it to the list
		Msg("Looting '"+name+"' of workmanship "+work+" or better.");
		break;
	case "move":	// Move selected scrolls
		var name, mask=0, skill, nbr=0;	// Default to no selection mask
		var aco= skapi.acoSelected;
		if(!aco) {Msg("No move target has been selected."); break;}
		var give= aco.oty & (otyPlayer|otyMerchant); // Use give mode?
		if(!give && !(aco.oty & otyContainer)) {Msg("Move target isn't a container."); break;}
		if(aco==skapi.acoChar) give= false;	// Special case, player is main pack
		var slow= !aco.fInInventory; // Will the move be slow?
		var str= give ? "Giving" : "Moving";
		var Filter= skapi.AcfNew();	// Init scroll filter
		Filter.szName= "Scroll of *"; // Only check for scrolls
		Filter.olc= olcInventory;	// Only my inventory
		var Scrolls= Filter.CoacoGet();	// Scan for scrolls
		var bits, scroll, spid, cnt= Scrolls.Count;
		if(!cnt) {Msg("No scrolls found in inventory."); break;}
		if(word.length>1) {
			name= cmd.slice(5);		// Get name to check
			mask= Char[name];		// Get skill bits
			if(!mask) {Msg("'"+name+"' isn't configured."); break;}
			skill= mask & 15;		// Get the magic skill types
			mask &= -16;			// Get the selection bit
			Msg(str+" scrolls for "+name+" to "+aco.szName);
		} else Msg(str+" unusable scrolls to "+aco.szName);
		while(cnt--) {				// Check all the found scrolls
			scroll= Scrolls(cnt);	// Get the next scroll
			spid=  scroll.spellid;	// Get spell id
			if(!spid) continue;		// Skip if not valid
			if(mask) {				// Filter scrolls by mask?
				bits= Spell[spid];
				if(!bits) bits= AddSpell(spid); // Add if undefined
				if(bits&mask) continue; // Skip if known
				if(!(bits&skill)) continue; // Skip if not usable
			} else if(!CheckScroll(spid,true)) continue; // Skip if usable
			if(give) scroll.MoveToStack(aco); // Initiate the give
			else scroll.MoveToContainer(aco); // Move it to container
			nbr++;					// Count moves
			if(slow) {
				skapi.WaitEvent(500,wemSpecific,evidOnRemoveFromInventory);
				skapi.WaitEvent(1200,wemFullTimeout); // Give it some extra time
			} else skapi.WaitEvent(500,wemSpecific,evidOnAddToInventory);
		}
		if(nbr) Msg("Moved "+nbr+" scrolls.");
		else Msg("No scrolls found to move.");
		break;
	case "npc":		// Scan area for npcs
		var str=":", mo, n;
		if(word.length>1) {
			var temp="";
			if(word.length>2) temp= cmd.slice(9).toLowerCase(); // Get template name
			switch(word[1]) {	// Modify loot list?
			case "list":			// Display the monster list
				if(!MD) {Msg("Monster list not enabled."); break;}
				var lvl= parseInt(temp);
				if(temp) str= " for '"+temp+"':";
				Msg("Current monster list"+str);
				for(name in MD) {
					mo= MD[name];	// Get the monster object
					if(!isNaN(lvl)) {	// Special check by level?
						if(lvl<1) {		// XP level check?
							if(!mo.X) continue; // XP defined?
							if(!mo.X[-lvl]) continue; // XP level match?
						} else if(mo.L!=lvl) continue; // Level match?
					} else if(temp && name.toLowerCase().indexOf(temp)<0) continue; // Match?
					str= name+":L"+mo.L;
					if(mo.H) str += ", H="+mo.H;
					if(mo.S) str += ", S="+mo.S+", M="+mo.M;
					if(n=SkillStr(mo.A)) str += ", A("+n+")";
					if(n=SkillStr(mo.D)) str += ", D("+n+")";
					if(mo.X) {		// Got xp data?
						str += ", X=";
						for(n in mo.X) str += " "+FmtNbr(mo.X[n])+"@"+n;
					}
					Msg(str);
				}
				break;
			case "new":				// Start a new monster list
				MD= {};				// Empty DB
				Msg("Starting new monster list.");
				break;
			case "save":			// Save the loot list
				cf = fso.OpenTextFile(Title+".md", ForWriting, true);	// Create file
				cf.WriteLine("// Monster Database. Edit carefully.\n");
				cf.WriteLine("MD = "+ObjectToString(MD,true)+";");
				cf.Close();
				Msg("Monster list saved in '"+Title+".md'.");
				break;
			default: Msg("Unknown npc command, "+word[1]);
			}
			break;
		}
		var NPC= skapi.CoacoFromOcm(ocmMonster); // Build monster list
		var name, Names={}, cnt= NPC.Count;	// Get count
		if(cnt<1) {Msg("No monsters found."); break;}
		Msg("Found "+NPC.Count+" monsters.");
		NPC.Sort(skapi.sortbyName);		// Sort the list
		while(cnt--) {
			name= NPC.Item(cnt).szName;	// Get next NPC name;
			if(Names[name]) Names[name]++; // Inc existing count?
			else Names[name]= 1;		// Add new name
		}
		for(name in Names) {
			str= ") ";		// Default suffix
			if(MD) {		// Monster DB?
				mo= MD[name];	// Get the monster object
				if(mo) {		// Known monster?
					str += "L="+mo.L; // Add level
					if(mo.X) {	// XP data?
						var lvl= skapi.lvl;		// My level
						if(lvl<mo.L+5) lvl=0;	// If below max xp threshhold, lvl=0
						if(mo.X[lvl]) str += ", XP="+FmtNbr(mo.X[lvl]);
					}
				} else str += "*new*"; // Undefined monster
			}
			Msg(name+"("+Names[name]+str);
		}
		break;
	case "one":		// Toggle single target actions
		One = !One;
		SetCtlCheck("cbOne",One); // Switch the control check box
		Msg("One target is "+(One ? "on" : "off"));
		break;
	case "quit": 	// Set quit flag
		Quit= true;
		Msg("Quit flag set");
		break;
	case "range":	// Display/set the maximum range to loot
		if(word.length>1) {
			nbr = parseInt(word[1]);
			if(isNaN(nbr) || nbr<1) {Msg("Range should be >0"); break;}
			Range= nbr/100;				// Save the value
			SetCtlValue("tbRng",nbr);	// Update control value
		}
		Msg("Limiting actions to a maximum range of "+Range);
		break;
	case "ratio":	// Display/set the minimum value/weight ratio
		if(word.length>1) {
			nbr = parseFloat(word[1]);
			if(isNaN(nbr) || nbr<1) {Msg("Ratio should be >1"); break;}
			Ratio= nbr;				// Save the value
			SetCtlValue("tbRat",Ratio);	// Update control value
		}
		Msg("Minimum value/weight ratio="+Ratio);
		break;
	case "restore": // Restore vitals
		if(!(skapi.eqmEquipped&eqmFocusWeapon)) {Msg("Magic weapon not equipped"); break;}
		CombatMode(false);			// Make sure we are in combat mode
		RestoreVitals(90);			// Restore to at least 90%
		break;
	case "salvage":	// Start a salvage operation
		var aco, cnt, all=false, ust= skapi.AcoFindInInv("Ust"); // Salvage tool
		if(!ust) {Msg("An Ust is required for salvage operation."); break;}
		var WI= ChatSize(-150);					// Salvage window position
		if(word.length>1) switch(word[1]) {
			case "all": all= true;	// Salvage all?
				break;
			case "auto":			// Toggle auto salvage
				AutoS = !AutoS;
				Msg("Auto salvage is "+(AutoS ? "on" : "off"));
				return;
			case "list":			// List salvage collection
				cnt= Salvage.Count;	// # of items in the list
				if(!cnt) {Msg("No items in salvage list."); return;}
				var str= "";
				while(cnt--) {		// Process salvage list
					aco= Salvage(cnt); // Get next item in list
					if(!aco.fExists || !aco.fInInventory) { // Still have item?
						Salvage.RemoveAco(aco); // Remove from list
						continue;
					}
					if(str) str += ", "; // Need delimiter?
					str += aco.szName; // Add the next name
				}
				Msg("Items to salvage: "+str);
				return;
			case "loot":			// Process salvage collection
				cnt= Salvage.Count;	// # of items in the list
				if(!cnt) {Msg("No items in salvage list."); return;}
				ust.Use();			// Open the salvage window
				Msg("Salvaging "+cnt+" items.");
				do {
					var name, mc, code= 0;	// Clear material code
					while(cnt--) {			// Process salvage list
						aco= Salvage(cnt);	// Get next item in list
						if(!aco.fExists || !aco.fInInventory) { // Still have item?
							Salvage.RemoveAco(aco); // Remove from list
							continue;
						}
						mc= aco.oai.ibi.material;	// Get material code
						if(code) {					// Do we have a code yet?
							if(mc!=code) continue;	// Skip if not the same
						} else code= mc;			// Set the code type
						aco.AddToUst();				// Move to salvage window
						Salvage.RemoveAco(aco); 	// Remove from list
					}
					for(name in Material) if(code==MtlName[name]) break; // Get name
					str= "Salvaged "+name+" (*)";	// Name of the bag
					aco= skapi.AcoFindInInv(str);	// Find bag, if there is one
					if(aco && aco.cuseLeft<100) aco.AddToUst(); // Salvage if not full
					skapi.MouseMove(-370,WI);		// Move to salvage button
					skapi.MouseButton(ibuttonLeft);	// Do the salvage
					skapi.WaitEvent(700,wemSpecific,evidOnAddToInventory); // Wait for it
					cnt= Salvage.Count;				// Get the new list size
				} while(cnt);
				return;
			default: Msg("Undefined salvage option, "+word[1]); return;
		}
		Me.Use();					// Display our main pack contents
		ust.Use();					// Open the salvage window
		cnt= Me.citemContents;		// # of items in main pack
		var UI= skapi.chop & chopStretchUI ? 0 : -480; // Position adjust
		while(cnt--) {				// Check everything in the main pack
			aco= Me.AcoFromIitem(cnt); // Get the next item
			if(!MtlCode[aco.material]) continue; // Ignore if not a desired material
			if(aco.szName.slice(0,8)=="Salvaged") continue; // Ignore salvage sacks
			if(Assess(aco)) continue;	// Assess if needed
			var oai= aco.oai;			// Get assess properties
			if(!aco.oai) continue;		// Ignore if not available
			if(oai.ibi.szInscription) continue;	// Ignore if inscribed
			var work=oai.ibi.workmanship;
			if(work<MtlCode[aco.material]) continue; // Ignore if not good enough
			aco.AddToUst();							// Move to salvage window
			skapi.MouseMove(-370,WI);				// Move to salvage button
			if(!all) return;			// Stop if not 'all'
			skapi.MouseButton(ibuttonLeft);			// Do the salvage
			skapi.WaitEvent(700,wemSpecific,evidOnAddToInventory); // Wait for it
		}
		if(all) Msg("All suitable material has been salvaged.");
		else Msg("Nothing suitable to salvage was found.");
		break;
	case "save":	// Save configuration settings
		var filename=Title+".cfg";
		var C={Armor:Armor,Cantrip:Cantrip,Check:Check,Eat:Eat,EatP:EatP,Find:Find,
			Gnd:Gnd,Hot:Hot,LootAll:LootAll,LootAttack:LootAttack,Range:Range,
			Ratio:Ratio,Scarab:Scarab,Scroll:Scroll,Tank:Tank,Value:Value,xpLog:xpLog};
		Cfg[skapi.szName+"@"+skapi.szWorld]= C; // Store by charname and worldname
		SaveCfg(filename);
		Msg("Current configuration saved in "+filename);
		break;
	case "savesp":	// Save spell configuration settings
		Msg("Formatting spell list...");
		SaveSpellCfg(cfgFile);
		Msg("Spell configuration saved in "+cfgFile);
		break;
	case "scan":	// Scan area for corpses, etc.
		var Filter= skapi.AcfNew();	// Init corpse filter
		Filter.ocm= ocmMonsterCorpse; // Only check for corpses
		Filter.distMax= Range;		// Max distance to check
		Corpses= Filter.CoacoGet();	// Scan for corpses
		Msg("Found "+Corpses.Count+" corpses.");
		if(!Gnd) break;				// Check ground loot too?
		Filter= skapi.AcfNew();		// Init loot filter
		Filter.olc= olcOnGround;	// Only check on the ground
		Filter.ocm= ocmEquipment;	// Only check for equipment
		Filter.oty= otySelectable;	// It must be selectable
		Filter.distMax= Range;		// Max distance to check
		GndLoot= Filter.CoacoGet();	// Scan for loot
		Msg("Found "+GndLoot.Count+" ground loot items.");
		break;
	case "scarab":	// Display/set the minimum scarab level to collect
		if(word.length>1) {
			nbr = parseInt(word[1]);
			if(isNaN(nbr) || nbr<1 || nbr>7) {Msg("Scarab should be 1-7"); break;}
			Scarab= nbr;				// Save the value
			SetCtlValue("tbScrb",Scarab); // Update control value
		}
		Msg("Collecting scarabs of at least level "+Scarab);
		break;
	case "scroll":	// Display/set the minimum scroll level to collect
		if(word.length>1) {
			nbr = parseInt(word[1]);
			if(isNaN(nbr) || nbr<0 || nbr>7) {Msg("Scroll should be 0-7"); break;}
			Scroll= nbr;				// Save the value
			SetCtlValue("tbScrl",Scroll); // Update control value
		}
		if(Scroll) Msg("Collecting scrolls of at least level "+Scroll);
		else Msg("Scroll looting disabled.");
		break;
	case "sell":	// Sell to vendor
		var len, row=0;
		if(!Vendor) {Msg("Open a vendor window to sell to."); break;}
		if(word.length>1) {
			row = parseInt(word[1]);
			if(isNaN(row) || row<1 || row>17) {Msg("Row # should be 1-17"); break;}
		}
		var Filter= skapi.AcfNew();		// Init sell filter
		Filter.mcm= Vendor.buys;	// Only salable items
		Filter.cpyMax= Vendor.max;	// Don't exceed price limit
		var Sell= Filter.CoacoGet(Me.coacoContents); // Check items in main pack
		var cnt=Sell.Count;
		if(!cnt) {Msg("No items found to sell."); break;}
		var aco= Vendor.aco;		// Get the vendor object
		var name, nbr=0;
		while(cnt--) {				// Process all the ites to sell
			var item= Sell(cnt);	// Get the next item
			if(NoSell[item]) continue; // Skip flagged items
			if(row && item.iitem/6+0.1>row) continue; // Beyond the row count?
			if(!item.cpyValue) continue; // Can't sell items with no value
			name= item.szName;		// Get item name
			if(Loot[name] || LootName.test(name)) continue; // Skip loot items
			word= name.split(" ");
			if(word[0]=="Scroll" || word[word.length-2]=="Scroll") continue; // Skip scrolls
			if(word[1]=="Keyring" || word[0]=="Salvaged") continue; // Skip keyrings, etc.
			if(Assess(item)) continue;	// Assess if needed
			if(item.oai.ibi.szInscription) {NoSell[item]=true; continue;} // Skip if inscribed
			item.MoveToStack(aco);	// Move it to the vendor
			nbr++;					// Count moves
		}
		if(!nbr) {Msg("No suitable items found to sell."); break;}
		Msg("Selected "+nbr+" items to sell at "+Math.round(Vendor.buypct*100)+"%.");
		skapi.MouseMove(-340,ChatSize(-133)); // Move to sell all button
		break;
	case "set": 	// Set a control setting
		if(word.length<2) {Msg("Set what control?"); break;}
		if(word.length<3) {Msg("Set what control property?"); break;}
		if(word.length<4) {Msg("Set what control value?"); break;}
		var val= word[3];
		if(val=="null") val= "";
		skapi.SetControlProperty(Title,word[1],word[2],val);
		break;
	case "skills":	// List magic skills
		var name=skapi.szName ,str="", mask=cMask, bit=1, skinfo, skid=skidCreatureEnchantment;
		if(word.length>1) {
			name= cmd.slice(7);		// Get name to check
			mask= Char[name];		// Get skill bits
			if(!mask) {Msg("'"+name+"' isn't configured."); break;}
		}
		for(;skid<=skidWarMagic;skid++,bit<<=1) { // Check all 4 magic skills
			skinfo= skapi.SkinfoFromSkid(skid); // Get info for this skill
			if(mask & bit) str += (str=="" ? " " : ", ")+skinfo.szName;
		}
		if(str=="") str= " (none)";
		Msg("Magic skills for "+name+":"+str);
		break;
	case "sort":	// Sort pack contents by value/weight
		var aco, name, last=0, cnt=Me.citemContents, coaco=skapi.CoacoNew();
		var sortby= skapi.sortbyValue, sortName="value";
		if(word.length>1) {
			var row = parseInt(word[1]);
			if(isNaN(row) || row<1 || row>17) {Msg("Row # should be 1-17"); break;}
			if(cnt>row*6) cnt= row*6; // Limit items to sort?
			if(word.length>2) switch(word[2]) {
			case "vw": sortName="value/weight";
				sortby= {CompareAcos:SortByValueWeight};
				break;
			case "w": sortName="weight";
				sortby= {CompareAcos:SortByWeight};
				break;
			default: Msg("Unknown sort type, "+word[2]);
			case "v":	// Included redundant setting for completeness
				return;
			}
		}
		Msg("Checking "+cnt+" inventory items.");
		while(cnt--) {				// Build a collection of items to sort
			aco= Me.AcoFromIitem(cnt);
			if(!aco || !aco.cpyValue) continue; // Skip items with no value
			if(NoSell[aco]) continue; // Skip flagged items
			name= aco.szName;		// Get item name
			if(name=="Pyreal") continue; // Never sort pyreals
			if(Loot[name] || LootName.test(name)) continue; // Skip loot items
			if(name.split(" ")[0]=="Scroll") continue; // Skip scrolls
			if(Assess(aco)) continue;	// Assess if needed
			if(aco.oai.ibi.szInscription) {NoSell[item]=true; continue;} // Skip if inscribed
			coaco.AddAco(aco);		// Add it it collection
		}
		var nbr= coaco.Count;		// Item count
		if(!nbr) {Msg("No items found to sort."); break;}
		Msg("Sorting "+nbr+" inventory items by "+sortName);
		coaco.Sort(sortby);			// Do the sort
		while(nbr--) {				// Move in sorted order
			coaco(nbr).MoveToContainer(Me); // Move to start of pack
			skapi.WaitEvent(900,wemSpecific,evidOnAddToInventory); // Wait for it to complete
		}
		break;
	case "speed":	// Do a run speed check
		skapi.Keys(cmidAutoRun);			// Start running
		Msg("Starting speed check");
		skapi.WaitEvent(1000,wemFullTimeout); // Wait until we get up to speed
		aTime.cmsec= 0;						// Reset action timer
		sLoc= skapi.maplocCur;				// Remember out start location
		skapi.WaitEvent(15000,wemFullTimeout); // Run for 10 seconds
		var dTime= aTime.cmsec/60000; 		// Get elapsed time in minutes
		var dLoc= sLoc.Dist3DToMaploc(skapi.maplocCur); // Get distance run
		skapi.Keys(cmidReady), IgnoreS=true; // Stop running
		Msg("Speed = "+(dLoc/dTime).toFixed(2)+" map units/minute.");
		break;
	case "spells":	// Add known spells to list
		AddSpells();	// Add the spells
		break;
	case "stack":	// Stack pyreals in main pack
		var part=0, pval, free=0, merge=0;
		var pack=skapi.AcoFromIpackIitem(0,-1) ,cnt=pack.citemContents;
		while(cnt--) {				// Check all the pack items
			aco= pack.AcoFromIitem(cnt); // Get the next item
			if(aco.szName!="Pyreal" || aco.cpyValue==pyMax) continue;
			if(part) {				// Do we have a partial stack to merge?
				merge++;			// Count merges
				var sum= aco.cpyValue+pval; // Combined value of the stacks
				aco.MoveToStack(part); // Merge the stacks
				skapi.WaitEvent(1000,wemSpecific,evidOnAdjustStack); // Wait for completion
				skapi.Sleep(150);	// Make sure its had time to finish
				if(sum>pyMax) part= aco, pval= sum-pyMax; // Get the new split stack
				else {
					free++;			// Count freed slots
					if(sum==pyMax) part= 0; // No partial stack left
					else pval= sum;	// Combined partial stack value
				}
			} else part= aco, pval= part.cpyValue; // Remember partial stack
		}
		if(part) part.MoveToPack(0,0); // Move any partial to the top of the pack
		if(merge==0) Msg("No pyreals found that could be stacked.");
		else Msg("Merged "+merge+" pyreal stacks and freed "+free+" pack slots.");
		break;
	case "stat":	// for debug testing
		Msg("Stamina="+skapi.SkinfoFromVital(vitalStaminaMax).lvlCur);
		break;
	case "stop":	// Stop ongoing action
		rtn= DoStop(true,"");
		if(!rtn) Msg("No general activity to stop");
		break;
	case "tank":	// Toggle El Tank support mode/ set timeout
		if(word.length>1) {
			nbr = parseInt(word[1]);
			if(isNaN(nbr) || nbr<4) {Msg("The time should be >3"); break;}
			Tank= nbr;			// Save the value
			Msg("Tank timeout is now "+Tank+" seconds");
		} else Tank= !Tank;
		SetCtlCheck("cbTank",Tank); // Switch the control check box
		Msg("Tank mode is "+(Tank ? "on" : "off"));
		if(skapi.KeyState(Pause)) skapi.Keys(Pause); // Pause tank
		break;
	case "token":	// Give casino tokens
		if(!skapi.AcoFindInInv("* Token")) {Msg("No tokens found."); break;}
		GMtype= null;				// We may not be at GM yet
		Action= DoToken;			// Set current action as giving tokens
		Cost= Val= 0, Target= null;	// Init. for value tracking
		break;
	case "tusk":	// Enable next tusk/pincer pickup
		Tusk = true;
		SetCtlCheck("cbTusk",Tusk); // Switch on the control check box
		Msg("The next tusk or pincer will be looted.");
		break;
	case "unlock":	// Unlock Mnemosynes
		var Filter= skapi.AcfNew();	// Init Mnemosyne filter
		Filter.szName= "* Mnemosyne"; // Only check for Mnemosynes
		Filter.olc= olcInventory;	// Only my inventory
		var Mnems= Filter.CoacoGet(); // Scan for Mnemosynes
		var cnt=Mnems.Count;
		while(cnt--) {				// Check for already unlocked
			var aco= Mnems(cnt);
			if(aco.szName.split(" ")[2]!="Mnemosyne") Mnems.RemoveAco(aco);
		}
		var cnt=Mnems.Count;		// Get updated count
		if(!cnt) {Msg("No mnemosynes found to unlock."); break;}
		Msg("Unlocking "+cnt+" mnemosynes...");
		while(cnt--) {
			var aco= Mnems(cnt);	// Get the next Mnemosyne
			var type= MnemKeys[aco.szName.split(" ")[1]]; // Get key type needed
			var key= skapi.AcoFindInInv("Intricate "+type+" Key");
			if(!key) {Msg("No "+type+" key found to unlock with."); break;}
			while(aco.fExists) {	// Repeat until it works
				key.UseOnAco(aco);	// Unlock the Mnemosyne
				skapi.WaitEvent(900,wemSpecific,evidOnActionComplete); // Wait for completion
			}
		}
		Msg("Unlocking completed.");
		break;
	case "value":	// Display/set the minimum loot value
		if(word.length>1) {
			nbr = parseInt(word[1]);
			if(isNaN(nbr) || nbr<1) {Msg("Value should be >0"); break;}
			Value= nbr;			// Save the value
			SetCtlValue("tbValue",Value); // Update control value
		}
		Msg("Collecting loot items with a value of at least "+Value);
		break;
	case "weapon":	// Display/set the weapons to loot
		if(word.length<2) {			// Just display list?
			var s= "";
			for(name in Weapons) {	// Get all the names
				if(!Weapons[name]) continue;
				if(s!="") s += ", "; // Separator needed?
				s += name+"="+Weapons[name]; // Add the name to the list
			}
			if(s) Msg("Looting: "+s);
			else Msg("No weapons have been configured for looting.");
			break;
		}
		var name= Caps(word[1]);	// Get weapon name
		var nbr= Weapons[name];		// Get weapon damage
		if(typeof nbr!="number") {Msg("'"+name+"' isn't a recognized weapon skill."); break;}
		if(word.length<3) {			// Just display list?
			if(!nbr) {Msg("'"+name+"' isn't configured."); break;}
			Weapons[name]=0;			// Clear the value
			Msg("'"+name+"' removed from weapon list.");
			break;
		}
		nbr= parseInt(word[2]);		// Get weapon damage
		if(isNaN(nbr) || nbr<2) {Msg("Weapon damage should be >1"); break;}
		Weapons[name]= nbr;			// Configure the weapon type
		Msg("Looting "+name+"s with damage of "+nbr+" or better.");
		break;
	case "xp":		// Toggle logging xp messages
		xpLog = !xpLog;
		SetCtlCheck("cbXP",xpLog); // Switch the control check box
		Msg("XP logging is "+(xpLog ? "on" : "off"));
		break;
	default: Msg("Unknown comand: "+word[0]);
	}
	word= null;		// Clear command flag
}

// Handler function for the OnControlEvent event.
function OnControlEvent(Panel,Control,Value) {	// This indicates that the control panel was used
	if(Panel!=Title && Panel!="Enter Name") return;	// Ignore if its not our panel
	var val= Value(Control);	// Get the control value
	if(Log) Msg("Control name="+Control+", Value="+val);
	switch(Control) {			// Handle the control that was used
	case "cbAll":  TaskAdd(OnCommand,"all",0,0,0);	// Do all command
		break;
	case "pbAdd":									// Add a Go location
		skapi.ShowControls(NameSchema,true); // Display the control panel
		skapi.GetControlProperty(Title2,"ebLoc","Capture"); // Activate the edit
		break;
	case "cbAuto": TaskAdd(OnCommand,"auto",0,0,0);	// Do auto command
		break;
	case "pbBuy":  TaskAdd(OnCommand,"buy",0,0,0);	// Do buy command
		break;
	case "tbBuy":  TaskAdd(OnCommand,"buy "+val,0,0,0);	// Do buy command with value
		break;
	case "pbChars": TaskAdd(OnCommand,"chars",0,0,0); // Do chars command
		break;
	case "pbCheck": TaskAdd(OnCommand,"check",0,0,0);	// Do check command
		break;
	case "pbCncl":									// Cancel Add Location
		skapi.RemoveControls(Title2); // Remove the name control panel
		skapi.ShowControls(Title,true); // Restore the control panel
		break;
	case "cbEat":  TaskAdd(OnCommand,"eat",0,0,0);	// Do eat command
		break;
	case "tbEatP": TaskAdd(OnCommand,"eat "+val,0,0,0);	// Do eat command with value
		break;
	case "pbFill": ChatMsg("@fillcomps");			// Say @fillcomps online command
		break;
	case "cbFind": TaskAdd(OnCommand,"find",0,0,0);	// Do find command
		break;
	case "pbFriends": ChatMsg("@friends online");	// Say @friends online command
		break;
	case "pbFrLog": TaskAdd(OnCommand,"friends",0,0,0); // Do friends command
		break;
	case "pbGo":									// Do go command
		var loc= Value("cmLoc");	// Get current location selection
		if(loc=="") Msg("No location selected.");
		else TaskAdd(OnCommand,"go "+loc,0,0,0);
		break;
	case "cbHot": TaskAdd(OnCommand,"hot",0,0,0);	// Do hot command
		break;
	case "pbHouse": ChatMsg("@house recall");		// Say @house recall command
		break;
	case "pbKill": TaskAdd(OnCommand,"kill",0,0,0);	// Do kill command
		break;
	case "pbLife": ChatMsg("@lifestone");			// Say @lifestone command
		break;
	case "pbList":									// Do list command
		var name= Value("cmChar");	// Get current character selection
		if(name=="") TaskAdd(OnCommand,"list",0,0,0);
		else TaskAdd(OnCommand,"list "+name,0,0,0);
		break;
	case "ebLoc":									// Add the location
		var name= Value("ebLoc");	// Get the location name
		if(name=="") {				// Nothing entered?
			Msg("No name entered.");
			skapi.GetControlProperty(Title2,"ebLoc","Capture"); // Reactivate the edit
			break;
		}
		if(GoLoc[name]) {			// Duplicate?
			Msg("That name is already in use.");
			skapi.GetControlProperty(Title2,"ebLoc","Capture"); // Reactivate the edit
			break;
		}
		skapi.RemoveControls(Title2); // Remove the name control panel
		skapi.ShowControls(Title,true); // Restore the control panel
		var cso= skapi.acoSelected;	// Current selection
		if(cso && (cso.oty&otyPortal)) GoLoc[name]= cso.maploc.sz(3); // Set portal?
		else GoLoc[name]= skapi.maplocCur.sz; // Set the current location
		skapi.GetControlProperty(Title,"cmLoc","AddChoice('"+name+"')");
		skapi.SetControlProperty(Title,"cmLoc","Selected",LocCnt);
		skapi.SetControlProperty(Title,"cmLoc","Data('"+(LocCnt++)+"')",GoLoc[name]);
		break;
	case "pbLoot": TaskAdd(OnCommand,"loot",0,0,0);	// Do loot command
		break;
	case "cbLoot": TaskAdd(OnCommand,"looting",0,0,0);	// Do looting command
		break;
	case "pbMansion": ChatMsg("@house mansion_recall");	// Say @house mansion_recall command
		break;
	case "pbMove":									// Do move command
		var name= Value("cmChar");	// Get current character selection
		if(name=="") TaskAdd(OnCommand,"move",0,0,0);
		else TaskAdd(OnCommand,"move "+name,0,0,0);
		break;
	case "pbNPC": TaskAdd(OnCommand,"npc",0,0,0);	// Do npc command
		break;
	case "tbRat": TaskAdd(OnCommand,"ratio "+val,0,0,0); // Do ratio command with value
		break;
	case "pbRem":									// Remove current selection
		var name, loc= Value("cmLoc");	// Get current location selection
		if(loc=="") {Msg("No location selected."); break;}
		skapi.GetControlProperty(Title,"cmLoc","Clear"); // Clear the menu
		for(name in GoLoc) if(GoLoc[name]==loc) {delete GoLoc[name]; break;}
		BuildLocs();				// Rebuild the menu
		skapi.SetControlProperty(Title,"cmLoc","Selected",0);
		break;
	case "tbRng": TaskAdd(OnCommand,"range "+val,0,0,0); // Do range command with value
		break;
	case "pbSalv": TaskAdd(OnCommand,"salvage loot",0,0,0);	// Do salvage command
		break;
	case "pbSave": TaskAdd(OnCommand,"save",0,0,0);	// Do save command
		break;
	case "pbSaveSp": TaskAdd(OnCommand,"savesp",0,0,0);	// Do savesp command
		break;
	case "pbScan": TaskAdd(OnCommand,"scan",0,0,0);	// Do scan command
		break;
	case "pbSpells": TaskAdd(OnCommand,"spells",0,0,0);	// Do spells command
		break;
	case "tbScrb": TaskAdd(OnCommand,"scarab "+val,0,0,0); // Do scarab command with value
		break;
	case "tbScrl": TaskAdd(OnCommand,"scroll "+val,0,0,0); // Do scroll command with value
		break;
	case "pbSell": TaskAdd(OnCommand,"sell",0,0,0); // Do sell command
		break;
	case "pbStack": TaskAdd(OnCommand,"stack",0,0,0); // Do stack command
		break;
	case "pbStop": if(!DoStop(true,"")) Msg("No general activity to stop");
		break;
	case "nbTabs":									// Go tab selected?
		if(val==4) {			// Target monitoring selected?
			CST= null;			// Force re-access
			tTime.cmsec= -1;	// Trigger target timer
			break;
		}
		tTime.cmsec= 0;			// Clear target timer
		if(val!=3) break;
		if(Schema && !LocCnt) BuildLocs();	// Build location list?
		break;
	case "cbTank": TaskAdd(OnCommand,"tank",0,0,0);	// Do tank command
		break;
	case "pbToken": TaskAdd(OnCommand,"token",0,0,0); // Do token command
		break;
	case "pbTSave": TaskAdd(OnCommand,"npc save",0,0,0); // Do MD save command
		break;
	case "cbTusk": TaskAdd(OnCommand,"tusk",0,0,0);	// Do tusk command
		break;
	case "tbValue": TaskAdd(OnCommand,"value "+val,0,0,0); // Do value command with value
		break;
	case "cmTVul":				// Set a vulnerability
		if(!val) return;		// Ignore null selection
		var mo, aco= skapi.acoSelected; // Current selection
		if(!MD) {Mer("Monster DB not enabled."); return;} // No monster DB active?
		if(!aco) {Mer("No target selected."); return;} // No target active?
		if(!(aco.ocm&ocmMonster)) {Mer("Target isn't a monster."); return;}
		mo= MD[aco.szName];		// Monster object
		if(!mo) {Mer("Target isn't in Monster DB."); return;}
		if(val==mo.V) return;	// Already set?
		mo.V= val;				// Set vul type
		Msg(aco.szName+" vulnerability set to "+val);
		break;
	case "cbXP":   TaskAdd(OnCommand,"xp",0,0,0);	// Do xp command
		break;
	case "pbQuit": Quit= true;	// Set quit flag
		Msg("Quit flag set");
		break;
	}
}

function Mer(txt) {
	Msg(txt);		// Display error message
	skapi.SetControlProperty(Title,"cmTVul","Selected",-1); // Reset menu
}

// Handler function for the OnControlProperty event.
function OnControlProperty(Panel,Control,Property,Value) {	// GetControlProperty was called
	if(Panel!=Title) return;	// Ignore if its not our panel
	if(!Log) return;
	Msg("Control="+Control+", Property="+Property+", Value="+Value);
	if(typeof Value=="number" && Value>0) Msg("Value="+Hex(Value));
}

// Handler function for the OnDeathMessage event.
function OnDeathMessage(msg) {		// This indicates that we have killed something
	aTime.cmsec= 0;			// Reset action timer
	if(!xpLog) return;		// Log kills?
	var killxp = dTotal - Math.round(1.1*dSkill);
	var fxp, fcnt= skapi.cofellow.Count; // Fellowship count
	if(fcnt>1 && FSxp) {	// In fellowship & sharing xp?
		fxp= Math.floor(killxp/Fpct[fcnt]); // Adjust for fellowship %
		Msg("Kill XP="+FmtNbr(killxp)+", Full="+FmtNbr(fxp)); // Display message
		killxp= fxp;		// for DB xp
	} else Msg("Kill XP="+FmtNbr(killxp)); // Display message
	var aco= skapi.acoSelected;
	if(!aco || !MD) return; // No target or no MD active?
	var name= aco.szName;	// Target name;
	if(msg.indexOf(name)<0) return; // Did we kill this target?
	var mo= MD[name];		// Monster BD object
	if(!mo) return;			// Ignore if undefined
	if(!mo.X) mo.X= {};		// Init xp list if needed
	var mlvl= mo.L; 		// Monster level
	var lvl= skapi.lvl;		// My level
	if(lvl<mlvl+4) lvl=1;	// If below max xp threshhold, lvl=1
	if(mo.X[lvl] && killxp<=mo.X[lvl]) return;
	mo.X[lvl]= killxp;		// Add new xp value
}

// Handler function for the OnFellowCreate event.
function OnFellowCreate(szName,fShareExp,oidLeader,cofellow) { // In fellowship
	FSxp= fShareExp;		// Remember if we're sharing
}

// Handler function for the OnEnd3D event.
function OnEnd3D() {		// This indicates that the character is logging out
	DoStop(true," due to logout"); // Stop any actions in progress
}

// Handler function for the OnHotkey event.
function OnHotkey(cmid,vk) { // A hotkey has been pressed
	if(skapi.fInChatBuffer) return; // Ignore chat keystrokes
	if(cmid=="S" && IgnoreS) {IgnoreS=false; return;} // Fix for dual key
	var cmd= HotKeys[cmid];
	if(!cmd) {Msg("Unknown hotkey: '"+cmid+"'."); return;}
	OnCommand(cmd);			// Do the command
}

// Handler function for the OnLeaveVendor event.
function OnLeaveVendor() {	// This indicates that the vendor is no longer available
	Vendor= null;			// Remove vendor object
}

// Handler function for the OnMeleeDamageOther event.
function OnMeleeDamageOther(name,dmg,type) { // This indicates that we damaged our target
	aTime.cmsec= 0;			// Reset action timer
	MissCnt= 0;				// Reset miss count
}

// Handler function for the OnMeleeEvadeOther event.
function OnMeleeEvadeOther(name) { // This indicates that our target evaded
	aTime.cmsec= 0;			// Reset action timer
	MissCnt= 0;				// Reset miss count
}

// Handler function for the OnMeleeLastAttacker event.
function OnMeleeLastAttacker(aco) {
	if(Nav==true) return;	// Ignore attacks during a go command
	if(Tank) aTime.cmsec= 0; // Reset action timer?
	Attacker= aco;			// Remember last attacker
	if(Action==DoKill) return; // We're expecting attacks in killing mode
	if(!aco.ocm) return;	// Ignore magic traps
	if(LootAttack && Action==DoLoot) return;	// Ignore attacks while looting?
	DoStop(false," due to attack");	// Stop what we're doing
	if(!Auto) return;		// Respond to attack?
	Action= DoKill;			// Prevent duplicate enqueue
	TaskAdd(OnCommand,"kill",0,0,0);
}

// Handler function for the OnNavStop event.
function OnNavStop(nsc) {
	if(Log) Msg("Navigation ended.");
	if(Nav<1) return;
	switch(nsc) {
	case nscArrived: if(Nav<2) Msg("Go completed.");
		break;
	case nscTimeout: Msg("Go timeout.");
	case nscCanceled:
		Nav= -1;			// Error flag
		break;
	default: Msg("Unknown nav code: "+nsc);
	}
	Nav= false;			// Clear the flag
}

// Handler function for the OnObjectCreate event.
function OnObjectCreate(aco) {
	if(aco.ocm & ocmMonsterCorpse) {	// Is it a monster corpse?
		if(!(aco.oid in Opened) || !Opened[aco.oid]) Corpses.AddAco(aco); // Add to list?
	} else if(aco.ocm & ocmMonster) {	// Is it a monster?
		if(Auto && !Action) Action= FindTarget; // Find it?
	} else if(Gnd && (aco.ocm & ocmEquipment) && (aco.olc & olcOnGround)) {	// Ground loot?
		if((aco.oty & otySelectable) && !(aco.oty & otyNoPickup) && !(aco.eqm & eqmAmmo)) {
			GndLoot.AddAco(aco);		// Add it to the loot list
			if(Log) Msg("Adding ground loot: "+aco.szName);
		}
	}
}

// Handler function for the OnObjectDestroy event.
function OnObjectDestroy(aco) {
	if(aco==Attacker) Attacker= null;	// Did attacker die (or disappear)?
	if(Corpses && Corpses.FContainsAco(aco)) Corpses.RemoveAco(aco); // Remove from list?
	if(HoldCorpses && HoldCorpses.FContainsAco(aco)) HoldCorpses.RemoveAco(aco); // Remove?
	if(aco.oid in Opened) delete Opened[aco.oid];	// Cleanup
	if(aco!=Target) return;				// Was our current target destroyed?
	Target= MissCnt= 0;					// Mark as gone
	if(Action!=DoKill) return;
	if(++KillCnt>MaxCnt) MaxCnt=KillCnt; // Increment kill count
	skapi.SetControlProperty(Title,"piCmd","value",KillCnt*100/MaxCnt);
	TaskAdd(DoTarget,0,0,evidOnActionComplete,500); // Aquire a new target?
}

// Handler function for the OnOpenContainer event.
function OnOpenContainer(aco) {
	if(!Looting) return;				// Is Looting disabled?
	if(aco.fInInventory) return;		// Ignore moving packs
	while(!aco.szName) {				// Wait until name is valid
		if(!aco.fExists) return 1;		// Object gone?
		skapi.WaitEvent(100);
	}
	if(aco.szName=="Storage" || aco.acoContainer=="Storage") return; // Ignore storage
	if(NextCorpse==aco) NextCorpse= null; // Clear flag?
	skapi.WaitEvent(100,wemFullTimeout); // Give it some extra time
	Contents= aco.coacoContents;		// Get current container contents
	CCnt= Contents.Count;				// # of items in container
	LootCnt= 0;							// Reset loot counter
	if(Log) Msg("Opened "+aco.szName+" with "+CCnt+" items");
	if(CCnt) {TaskAdd(DoContents,aco,CCnt,0,0); return;} // Process the contents
	Opened[aco.oid]= true;				// Remember what we've opened
	if(Corpses.FContainsAco(aco)) Corpses.RemoveAco(aco); // Remove from list
}

// Handler function for the OnRawServerMessage event.
function OnRawServerMessage(mty,mbuf) { // This is a raw message we enabled
	mbuf.SkipCb(16);		// Skip over the header
	switch(mty) {			// Handle the types we define
	case mtyAllegianceInfo: // Allegiance panel info
		AllegianceID= {};	// Empty object for clean start
		mbuf.SkipCb(12);	// Skip over rank, a.size, # fol.
		var cnt= mbuf.Get_WORD(); // Get the record count
		mbuf.SkipCb(26);	// Skip over undefined stuff
		while(cnt--) {		// Parse the allegiance records
			var rec= {};		// Empty object
			rec.patron= mbuf.Get_DWORD(); // Get the patron ID
			var id= mbuf.Get_DWORD(); // Get the member ID
			mbuf.SkipCb(4);		// Skip over undefined stuff
			rec.xp= mbuf.Get_DWORD(); // Get the xp produced
			mbuf.SkipCb(4);		// Skip over online flag
			rec.sex= mbuf.Get_BYTE(); // Get the gender (male=1)
			rec.race= mbuf.Get_BYTE(); // Get the race (aluv=1,gharu=2,sho=3)
			rec.rank= mbuf.Get_BYTE(); // Get the rank
			mbuf.SkipCb(1);		// Skip over undefined stuff
			rec.loyal= mbuf.Get_WORD(); // Get the loyalty
			rec.leader= mbuf.Get_WORD(); // Get the leadership
			mbuf.SkipCb(8);		// Skip over undefined stuff
			rec.name= mbuf.Get_String(); // Get the name
			mbuf.Align_DWORD();	// Realign the buffer
			AllegianceID[id]= rec; // Save the record
			MemberID[id]= rec.name; // Remember for log in/out
		}
		break;
	case mtyOnMemberLogin:	// Allegiance member login
		var id= mbuf.Get_DWORD(); // Get the member ID
		var state= mbuf.Get_DWORD(); // Get on/off state
		if(Log) Msg("Member "+Hex(id)+" is "+(state ? "on" : "off"));
		var name= MemberID[id];
		if(!name) break;
		LogFriend(name,state);
		break;
	}
}

// Handler function for the OnSpellFailSelf event.
function OnSpellFailSelf(arc) { // Something failed
	if(Log) Msg("Action result code="+arc);
	switch(arc) {			// Process the result code if relevent
	case arcCantMoveToObject: // We blocked from reaching an object
		if(Action==DoLoot) Msg("Corpse unreachable, skipping.");
		break;
	case arcChargedTooFar:	// We tried to attack something too far away
		aTime.cmsec= 0;		// Reset action timer
		if(Action==DoKill) skapi.Keys(cmidLowAttack); // Resume attack?
		break;
	case arcOutOfAmmo:		// We are out of ranged ammo
		if(Action!=DoKill) break;	// Were we in attack mode?
		Action= null, Auto= false;
		SetCtlCheck("cbAuto",Auto); // Switch the control check box
		Msg("Killing/Auto stopped due to lack of ammo.");
		break;
	case arcTooBusy:		// We started an action too soon
		if(Action==DoLoot && Task.first>1) Task.first--; // Repeat task?
		break;
	}
}

// Handler function for the OnStatSkillExp event.
function OnStatSkillExp(skid, Name, diff, xpTotal, dsklvl) { // A skill has increased
	Skill[0]= xpTotal-Skill[skid];		// Change in skill
	Skill[skid]= xpTotal;				// Save new total
	if(xpLog) Msg(Name+" XP=+"+FmtNbr(Skill[0])+"  (dif="+diff+")"); // Display xp
	if(!MD) return;			// No monster DB active?
	var tp= Dsk[skid];		// Attack type (defense skill)
	if(tp) {				// Did we evade an attack?
		if(!Attacker) return; // No current attacker?
		var name= Attacker.szName;	// Attacker name
		var mo= MD[name];		// Monster BD object
		if(!mo) return;			// Ignore if undefined
		if(!mo.A[tp]) mo.A[tp]= diff; // Set attack value
		else mo.A[tp]= Math.round((mo.A[tp]*7+diff)/8); // Running average
		skapi.SetControlProperty(Title,"stTA"+tp,"text",diff);
		skapi.SetControlProperty(Title,"stTA"+tp,"textcolor",0);
		return;
	}
	var aco= skapi.acoSelected;
	if(!aco) return;		// No current target?
	var name= aco.szName;	// Target name;
	var mo= MD[name];		// Monster BD object
	if(!mo) return;			// Ignore if undefined
	tp= Ask[skid];			// Weapon type
	if(!tp) return;			// Ignore if undefined
	if(!mo.D[tp]) mo.D[tp]= diff; // Set defense value
	else mo.D[tp]= Math.round((mo.D[tp]*7+diff)/8); // Running average
	skapi.SetControlProperty(Title,"stTD"+tp,"text",diff);
	skapi.SetControlProperty(Title,"stTD"+tp,"textcolor",0);
}

// Handler function for the OnStatTotalExp event.
function OnStatTotalExp(xp) { // The total xp has increased
	dTotal= xp-xpTotal;			// Change in total xp
	xpTotal= xp;				// Save new total
	if(Log && xpLog) Msg("Total XP gain="+dTotal);	// Display xp
	dSkill= dTotal-dUnspent;	// Difference must be skill xp
	Skill[0]= dUnspent= 0;		// To prevent double accounting
}

// Handler function for the OnStatUnspentExp event.
function OnStatUnspentExp(xp) { // The unspent xp has increased
	dUnspent= xp-Unspent;		// Change in unspent
	Unspent= xp;				// Save new total
	if(xpLog) if(!(Skill[0] || skapi.fCombatMode) || Log)
		Msg("Unassigned XP gain="+FmtNbr(dUnspent)); // Display xp?
	if(L126) OnStatTotalExp(skapi.expTotal); // Fake event for L126?
}

function ClearFields() {
	skapi.SetControlProperty(Title,"stTAM","text","");
	skapi.SetControlProperty(Title,"stTAR","text","");
	skapi.SetControlProperty(Title,"stTAW","text","");
	skapi.SetControlProperty(Title,"stTDM","text","");
	skapi.SetControlProperty(Title,"stTDR","text","");
	skapi.SetControlProperty(Title,"stTDW","text","");
	skapi.SetControlProperty(Title,"stTXP","text","");
}

// Handler function for the OnTimer event.
function OnTimer(to) {
	if(to!=tTime) return;		// Ignore if its not the target timer
	if(Action==DoFish) {Catch= -1; return;}
//	if(Log) Msg("OnTimer called.");
	var name, aco= skapi.acoSelected; // Current selection
	if(!aco) {					// No current selection?
		tTime.cmsec= -1000;		// Restart timer
		if(!CST) return;		// If no previous target, we're done
		skapi.SetControlProperty(Title,"stTName","text","");
		skapi.SetControlProperty(Title,"stTLvl","text","");
		skapi.SetControlProperty(Title,"stTHSM","text","");
		skapi.SetControlProperty(Title,"stTDist","text","");
		ClearFields();
		CST= null;				// Mark as clear
		return;
	}
	if(aco!=CST) {				// Change of target?
		CST= aco;				// Remember new target
		skapi.SetControlProperty(Title,"stTName","text",name=CST.szName);
		ClearFields();
		var vul="";
		if(CST.mcm&mcmCreature) { // Is this a creature?
			if(Assess(CST)) return;	// Assess if needed
			if(!CST.oai.cbi) return;	// Sanity check
			skapi.SetControlProperty(Title,"stTLvl","text",CST.oai.cbi.lvl);
			if(MD && (aco.ocm&ocmMonster)) { // Monster database active?
				if(mo=MD[name]) { // Monster defined?
					SkillField(mo.A,"stTA");	// Set attack fields
					SkillField(mo.D,"stTD");	// Set defense fields
					var mlvl= mo.L;			// Monster level
					var lvl= skapi.lvl;		// My level
					if(lvl<mlvl+4) lvl=1;	// If below max xp threshhold, lvl=1
					if(mo.X && mo.X[lvl])	// XP defined for this level?
						skapi.SetControlProperty(Title,"stTXP","text",FmtNbr(mo.X[lvl]));
					if(mo.V) vul= mo.V;		// Vul defined?
				} else {		// Add new entry
					Msg("Adding "+name+" to MD.");
					MD[name]= {L:CST.oai.cbi.lvl,H:0,S:0,M:0,A:{},D:{}}; // Add entry
				}
			}
		} else skapi.SetControlProperty(Title,"stTLvl","text","");
		skapi.SetControlProperty(Title,"stTHSM","text","");
		vul= vul ? DmgType[vul] : -1;		// Convert name to menu selection #
		skapi.SetControlProperty(Title,"cmTVul","Selected",vul);
	}
	tTime.cmsec= -1000;			// Restart timer
	var dist, mloc= CST.maploc;	// Get location
	if(mloc)  dist= skapi.maplocCur.Dist2DToMaploc(mloc)*100;
	else dist= "";
	skapi.SetControlProperty(Title,"stTDist","text",dist);
	if(!(CST.mcm&mcmCreature)) return; // If not creature, we're done
	var mo=null, mana="-", stam="-", hlth=0;
	if(CST.oai) hlth= CST.oai.cbi.healthCur;
	if(MD && (CST.ocm&ocmMonster)) { // MD active?
		mo= MD[name];			// Monster object
		if(mo && hlth>mo.H) mo.H= hlth; // Update health?
	}
	if(CST.oai.cai) {			// Detailed attributes available?
		stam= CST.oai.cai.staminaCur;
		mana= CST.oai.cai.manaCur;
		if(mo) {				// MD active?
			if(stam>mo.S) mo.S= stam; // Update stamina?
			if(mana>mo.M) mo.M= mana; // Update mana?
		}
	} else if(mo && mo.S) {		// Got DB data?
		stam= "("+mo.S+")";		// Fill in default values
		mana= "("+mo.M+")";
	}
	skapi.SetControlProperty(Title,"stTHSM","text",hlth+" / "+stam+" / "+mana);
}
